/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.creativecloud.cloudims;

import java.util.Map;

import javax.jcr.Session;

import org.apache.jackrabbit.api.security.user.User;
import org.apache.sling.commons.json.JSONObject;

import aQute.bnd.annotation.ProviderType;

/**
 * UserSupplier is a high level interface for mapping a set of information form a combination of sources to a user object.
 */
@ProviderType
public interface UserSupplier {
    /**
     * Obtains a user using the supplied parameters.
     * 
     * @param privilegedSession A session with enough privileges to create users.
     * @param autocreate Specifies that the user should be created if they do not already exist.
     * @param httpHeaders a map of headers from the request. This list contains only headers that were requested using configuraiton parameters.
     * @param bearerPayload This contains the payload portion of the bearer token
     * @param imsResult This contains the resulting content from IMS
     * @return
     */
    public User getUser(Session privilegedSession, boolean autocreate, Map<String, String> httpHeaders,
            JSONObject bearerPayload, JSONObject imsResult) {
		return null;
	}
}
