/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.creativecloud.home;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.jcr.RepositoryException;

import org.apache.jackrabbit.api.security.user.User;

import aQute.bnd.annotation.ProviderType;

/**
 * HomeSupplier gives you access to the sling path for a user's home folder for storing assets.
 */
@ProviderType
public interface HomeSupplier {

    /**
     * @return the path to a home folder. 
     * If the home folder does not exist, will be created.
     * Calling this method is the same as calling getOrCreateHome(user, true)
     * @return
     */
    @Nonnull
    public String getOrCreateHome(User user) throws RepositoryException {
		return null;
	}

    /**
     * Note: the default should always be to create if necessary. There are very
     * few cases where you want to get the dam home only if it exists.
     *
     * @return the path to a home folder that exists, or if !createIfNonExisting,
     *         null if the home directory does not exist.
     */
    @Nullable
    public String getOrCreateHome(User user, boolean createIfNonExisting) throws RepositoryException {
		return null;
	}

    /**
     * This returns the top level that contains all user homes irrespective of
     * depth
     *
     * @return
     */
    public String getHomesContainer() {
		return null;
	}
}
