package com.adobe.cq.dam.s7imaging;

/**
 * Scene7 Preset Type enum
 *
 */
public enum PresetType {
    VIEWER("viewer","presets/viewer"),
    IMAGE("image","imageserver/macros"),
    VIDEO("video","video/dynamicmedia");

    private String defaultPresetPath = "";
    private String name = "";

    PresetType(String name, String defaultPresetPath) {
        this.name = name;
        this.defaultPresetPath = defaultPresetPath;
    }

    public static PresetType getPresetTypeByName(String name){
        PresetType presetType = null;
        for(PresetType pt : PresetType.values()){
            if (pt.name.equalsIgnoreCase(name)) {
                presetType = pt;
                break;
            }
        }
        return presetType;
    }

    public String getDefaultPresetPath(){
        return this.defaultPresetPath;
    }

    public String getName(){
        return this.name;
    }

};