package com.adobe.cq.dam.s7imaging;

import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.tenant.Tenant;

import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

public class S7Preset {

    private static final String DEFAULT_PRESET_ROOT_PATH  = "/etc/dam/";
    private static final String TENANTS_BASE_PATH = "tenants/";
    private static final String PRESET_BASE_PATH = "/presets/";
    private static final String JCR_PRESET_ROOT_PATH = "/etc/dam/dynamicmediaconfig";
    private static final String JCR_PRESET_ROOT_PROP = "dynamicMediaPresetRoot";

    private PresetType presetType = null;
    private String tenantId = "";
    private String presetRootPath = "";

    /**
     *
     * @param presetTypeName preset type name defined in <code>PresetType</code>
     * @param resourceResolver resource resolver to get tenant information. If null is passed, it is used for out of the box preset path.
     */
    public S7Preset(String presetTypeName, ResourceResolver resourceResolver) {
        this.presetType = PresetType.getPresetTypeByName(presetTypeName);
        this.presetRootPath = DEFAULT_PRESET_ROOT_PATH;
        if (resourceResolver != null) {
            Tenant tenant = resourceResolver.adaptTo(Tenant.class);
            if (tenant != null) {
                tenantId = tenant.getId();
                this.presetRootPath = getPresetRootPath(resourceResolver);
            }
        }
    }

    /**
     * Get preset root path
     * @param resourceResolver
     * @return Preset root path if it is set; otherwise, it returns default root path.
     */
    private String getPresetRootPath(ResourceResolver resourceResolver){
		return null;
	}

    /**
     * Get preset path based on preset type and tenancy setup
     * @return preset root path
     */
    public String getPresetPath(){
		return null;
	}

}
