/*************************************************************************
  *
  * ADOBE CONFIDENTIAL
  * __________________
  *
  *  Copyright 2012 Adobe Systems Incorporated
  *  All Rights Reserved.
  *
  * NOTICE:  All information contained herein is, and remains
  * the property of Adobe Systems Incorporated and its suppliers,
  * if any.  The intellectual and technical concepts contained
  * herein are proprietary to Adobe Systems Incorporated and its
  * suppliers and may be covered by U.S. and Foreign Patents,
  * patents in process, and are protected by trade secret or copyright law.
  * Dissemination of this information or reproduction of this material
  * is strictly forbidden unless prior written permission is obtained
  * from Adobe Systems Incorporated.
  **************************************************************************/
package com.adobe.cq.dms.tagmanager;

/**
 * Represents a TagManager environment.
 */
public enum Environment {
    
    DEVELOPMENT("dev"),
    
    STAGE("stage"),
    
    LIVE("live");
    
    private String name;
    
    private Environment(String name) {
        this.name = name;
    }
    
    @Override
    public String toString() {
        return name;
    }
    
    /**
     * Returns a Environment for the provided <code>environment</code> String.
     * 
     * @param type String representation of environment (i.e. dev)
     * @return
     */
    public static Environment fromString(String environment) {
        for (Environment e : values()) {
            if (e.toString().equals(environment)) {
                return e;
            }
        }
        return null;
    }

}
