/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.projects.api;

/**
 * <code>ProjectException</code> provides a base {@link Exception} class for
 * {@link Project}s.
 */
public class ProjectException extends RuntimeException {
    private static final long serialVersionUID = 2484480587363909686L;

    /***
     * Default constructor.
     */
    public ProjectException() {
        super();
    }

    /**
     * Constructor that sets a message.
     * @param message a message describing the exception.
     */
    public ProjectException(String message) {
        super(message);
    }

    /**
     * Constructor that sets a message and cause of the exception.
     * @param message a message describing the exception.
     * @param cause the cause of the exception.
     */
    public ProjectException(String message, Throwable cause) {
        super(message, cause);
    }
}
