/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.searchcollections.api;

import javax.jcr.observation.Event;

/**
 * Interface class for extension of node indexing.
 */
public interface NodeIndexerExtension {

    /**
     * Check the event and return true if it indicates data has been modified
     * that affects the index.
     * 
     * @param event
     *            Event to check.
     * @return true if the event indicates data has been modified that should be
     *         indexed.
     */
    boolean checkEventModifiesIndex(Event event) {
		return false;
	}

    /**
     * Return the name of the index.
     * 
     * @return the name of the index.
     */
    String getName() {
		return null;
	}

    /**
     * Is this indexer extension enabled?
     * 
     * @return true if enabled
     */
    public boolean isEnabled() {
		return false;
	}
}
