/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.searchcollections.lucene;

import java.util.Arrays;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.Value;

import org.apache.jackrabbit.commons.JcrUtils;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.document.Field.Index;
import org.apache.lucene.document.Field.Store;
import org.apache.lucene.document.Field.TermVector;
import org.apache.lucene.facet.index.CategoryDocumentBuilder;
import org.apache.lucene.index.Term;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.TermQuery;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DefaultNodeIndexer implements NodeIndexer {

    private static final String primaryType = "jcr:primaryType";

    // --- fields    
    private static final String FIELD_UUID = ":uuid".intern();

    private static final String FIELD_FULLTEXT = ":fulltext".intern();

    private static final String FIELD_PRIMARY_TYPE = primaryType.intern();

    private static final String FIELD_PATH = ":path".intern();

    private static final String FIELD_PARENT = ":parent".intern();

    private static final String FIELD_NAME = ":name".intern();

    private static final String FIELD_LOCAL = ":local".intern();

    private static final String FIELD_PROPERTIES = ":properties".intern();

    // -- term query
    private static final Term TERM_PATH = new Term(":path");

    private static final int DEFAULT_MAX_AGGREGATION_LEVELS = 25;

    private static final List<String> DEFAULT_SKIP_PROPERTIES_LIST = Arrays
            .asList("sling:*", "jcr:created", "jcr:createdBy",
                    "jcr:lastModified", "jcr:lastModifiedBy", "cq:template",
                    "cq:toolbars", "cq:lastModified", "cq:lastModifiedBy",
                    "textIsRich", "isDate");

    private static final Logger log = LoggerFactory
            .getLogger(DefaultNodeIndexer.class);

    public Query getSubtreeQuery(final String path) {
		return null;
	}

    public Document createDocument(Node node, CategoryDocumentBuilder categoryDocBuilder) throws RepositoryException {
		return null;
	}

    // private static final Comparator<Fieldable> FIELDS_COMPARATOR_STORED = new
    // Comparator<Fieldable>() {
    // public int compare(Fieldable o1, Fieldable o2) {
    // return Boolean.valueOf(o2.isStored()).compareTo(o1.isStored());
    // }
    // };

    protected void copyAggregatesFromOriginal(Node node, Document doc)
            throws RepositoryException {
			}

    private void copyAggregatesFromOriginal(Node node, Document doc, int level)
            throws RepositoryException {
			}

    protected boolean shouldSkipChildNode(Node node, Node child, int levelDeep) {
		return false;
	}

    private boolean shouldSkipProperty(String name) {
		return false;
	}

    protected List<String> skipProperties() {
		return null;
	}

    protected int getAggregationMaxLevelsDeep() {
		return 0;
	}

    private void addValue(Document document, String name, Value value,
            boolean isFullText) throws RepositoryException {
			}
}
