/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.searchcollections.qom;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.jcr.RepositoryException;
import javax.jcr.UnsupportedRepositoryOperationException;
import javax.jcr.query.qom.And;
import javax.jcr.query.qom.ChildNode;
import javax.jcr.query.qom.Comparison;
import javax.jcr.query.qom.Constraint;
import javax.jcr.query.qom.DescendantNode;
import javax.jcr.query.qom.DynamicOperand;
import javax.jcr.query.qom.FullTextSearchScore;
import javax.jcr.query.qom.Length;
import javax.jcr.query.qom.LowerCase;
import javax.jcr.query.qom.NodeLocalName;
import javax.jcr.query.qom.NodeName;
import javax.jcr.query.qom.Not;
import javax.jcr.query.qom.Or;
import javax.jcr.query.qom.PropertyExistence;
import javax.jcr.query.qom.PropertyValue;
import javax.jcr.query.qom.QueryObjectModelFactory;
import javax.jcr.query.qom.SameNode;
import javax.jcr.query.qom.UpperCase;

/**
 * Returns a mapped constraint that only refers to the given set of
 * selectors. The returned constraint is guaranteed to match an as small
 * as possible superset of the node tuples matched by the given original
 * constraints.
 *
 * @param constraint original constraint
 * @param selectors target selectors
 * @return mapped constraint
 * @throws RepositoryException if the constraint mapping fails
 */
public class ConstraintSplitter {

    private final QueryObjectModelFactory factory;

    private final Set<String> leftSelectors;

    private final Set<String> rightSelectors;

    private final List<Constraint> leftConstraints =
        new ArrayList<Constraint>();

    private final List<Constraint> rightConstraints =
        new ArrayList<Constraint>();

    public ConstraintSplitter(
            Constraint constraint, QueryObjectModelFactory factory,
            Set<String> leftSelectors, Set<String> rightSelectors)
            throws RepositoryException {
        this.factory = factory;
        this.leftSelectors = leftSelectors;
        this.rightSelectors = rightSelectors;

        if (constraint != null) {
            split(constraint);
        }
    }

    /**
     * @return the left constraint
     */
    public Constraint getLeftConstraint() throws RepositoryException {
		return null;
	}

    /**
     * @return the right constraint
     */
    public Constraint getRightConstraint() throws RepositoryException {
		return null;
	}

    private void split(Constraint constraint) throws RepositoryException {
	}

    private void splitNot(Not not) throws RepositoryException {
	}

    private void splitBySelectors(Constraint constraint, Set<String> selectors)
            throws UnsupportedRepositoryOperationException {
			}

    /**
     * Returns the names of the selectors referenced by the given constraint.
     *
     * @param constraint constraint
     * @return referenced selector names
     * @throws UnsupportedRepositoryOperationException
     *         if the constraint type is unknown
     */
    private Set<String> getSelectorNames(Constraint constraint)
            throws UnsupportedRepositoryOperationException {
				return null;
			}

    /**
     * Returns the combined set of selector names referenced by the given
     * two constraint.
     *
     * @param a first constraint
     * @param b second constraint
     * @return selector names
     * @throws UnsupportedRepositoryOperationException
     *         if the constraint types are unknown
     */
    private Set<String> getSelectorNames(Constraint a, Constraint b)
            throws UnsupportedRepositoryOperationException {
				return null;
			}

    /**
     * Returns the selector name referenced by the given dynamic operand.
     *
     * @param operand dynamic operand
     * @return selector name
     * @throws UnsupportedRepositoryOperationException
     *         if the operand type is unknown
     */
    private String getSelectorName(DynamicOperand operand)
            throws UnsupportedRepositoryOperationException {
				return null;
			}

}
