/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.blog;

import java.text.DateFormat;
import java.util.Date;
import java.util.List;
import java.util.ResourceBundle;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;

import com.day.cq.tagging.Tag;
import com.day.cq.wcm.api.Page;

/**
 * {@linkplain Blog} represents a blog. It consisting of multiple instances of {@link BlogEntry}.
 * @deprecated replaced by com.adobe.cq.social.journal
 */
@Deprecated
public interface Blog {

    public static final String ANONYMOUS = "Anonymous";

    public static final String NODE_ENTRIES = "blogentries";

    public static final String URL_SUFFIX = ".html";
    public static final String FEED_SUFFIX = "/jcr:content.feed";
    public static final String TRACKBACK_SUFFIX = ".trackback.html";

    public static final String GENERATOR_NAME = "AEM Communities";
    public static final String GENERATOR_URL = "http://www.day.com/communique";

    public static final String PARAM_VIEW = "blog";
    public static final String PARAM_PERIOD = "period";
    public static final String PARAM_QUERY = "query";
    public static final String PARAM_TAG = "tag";
    public static final String PARAM_AUTHOR = "author";

    public static final String VIEW_DEFAULT = "default";
    public static final String VIEW_NEW = "new";
    public static final String VIEW_EDIT = "edit";
    public static final String VIEW_SEARCH = "search";
    public static final String VIEW_ARCHIVE = "archive";
    public static final String VIEW_AUTHOR = "author";
    public static final String VIEW_TAG = "tag";

    public static final String PROP_TITLE = "jcr:title";
    public static final String PROP_DESCRIPTION = "jcr:description";
    public static final String PROP_TEMPLATE = "cq:template";
    public static final String PROP_RESOURCE_TYPE = "sling:resourceType";
    public static final String PROP_BLOG_ARCHIVE = "blogarchive";

    public static final String DEFAULT_TEMPLATE = "/libs/social/blog/templates/page";
    public static final String DEFAULT_RESOURCE_TYPE = "social/blog/components/page";
    public static final String DEFAULT_TITLE = "Untitled";

    String AUTHOR_MAPPING_PREFIX = "/collabauthor";

    /**
     * Returns the entries in this blog.
     * @return The blog entries
     */
    List<BlogEntry> getEntries() {
		return null;
	}

    /**
     * Returns the entries in this blog using the specified filter.
     * @param filter The blog entry filter
     * @return The blog entries
     */
    List<BlogEntry> getEntries(BlogEntryFilter filter) {
		return null;
	}

    /**
     * Returns the entries in this blog using the specified filters.
     * @param filters The blog entry filters
     * @return The blog entries
     */
    List<BlogEntry> getEntries(List<BlogEntryFilter> filters) {
		return null;
	}

    /**
     * Returns the pages in this blog. Pages are special blog entries that don't show up in the timeline, e.g. an
     * "About" page.
     * @return The pages
     */
    List<BlogEntry> getPages() {
		return null;
	}

    /**
     * Returns the pages in this blog as a list of HTML links.
     * @return The pages as HTML
     * @see #getPages()
     */
    String getPagesAsHTML() {
		return null;
	}

    /**
     * Adds a new entry to this blog.
     * @param title The title of the blog entry
     * @param text The text of the blog entry
     * @param date The date of the blog entry (optional)
     * @return The blog entry
     */
    BlogEntry addEntry(String title, String text, Date date) {
		return null;
	}

    /**
     * Adds a new page to this blog. Pages are special blog entries that don't show up in the timeline, e.g. an
     * "About" page.
     * @param title The title of the blog entry
     * @param text The text of the blog entry
     * @return The blog entry
     */
    BlogEntry addPage(String title, String text) {
		return null;
	}

    /**
     * Returns the entry before the specified entry or <code>null</code> if the specified entry is the first one.
     * @param refEntry The reference entry
     * @return The previous entry
     */
    BlogEntry getPreviousEntry(BlogEntry refEntry) {
		return null;
	}

    /**
     * Returns the entry after the specified entry or <code>null</code> if the specified entry is the last one.
     * @param refEntry The reference entry
     * @return The next entry
     */
    BlogEntry getNextEntry(BlogEntry refEntry) {
		return null;
	}

    /**
     * Returns all tags entries in this blog are filed under.
     * @return The tags
     */
    Tag[] getTags() {
		return null;
	}

    /**
     * Returns the specified tag as an HTML link.
     * @param tag The tag
     * @return The HTML link
     */
    String getTagAsHTML(Tag tag) {
		return null;
	}

    /**
     * Returns the specified tag as an HTML link.
     * @param tag The tag
     * @param resourceBundle <code>ResourceBundle</code> to use for translations
     * @return The HTML link
     */
    String getTagAsHTML(Tag tag, ResourceBundle resourceBundle) {
		return null;
	}

    /**
     * Returns all tags entries in this blog are filed under as a list of HTML links.
     * @return The tags as HTML
     */
    String getTagsAsHTML() {
		return null;
	}

    /**
     * Returns all tags entries in this blog are filed under as a list of HTML links.
     * @param resourceBundle <code>ResourceBundle</code> to use for translations
     * @return The tags as HTML
     */
    String getTagsAsHTML(ResourceBundle resourceBundle) {
		return null;
	}

    /**
     * Returns the number of blog entries filed under the specified tag.
     * @param tag The tag
     * @return The number of blog entries
     */
    int getTagCount(Tag tag) {
		return 0;
	}

    /**
     * Returns all authors of this blog.
     * @return The authors
     */
    String[] getAuthors() {
		return null;
	}

    /**
     * Returns the specified author as an HTML link.
     * @param author The author name
     * @return The HTML link
     */
    String getAuthorAsHTML(String author) {
		return null;
	}

    /**
     * Returns the specified author as an HTML link.
     * @param author The author name
     * @param resourceBundle <code>ResourceBundle</code> to use for translations
     * @return The HTML link
     */
    String getAuthorAsHTML(String author, ResourceBundle resourceBundle) {
		return null;
	}

    /**
     * Returns all authors of this blog as a list of HTML links.
     * @return The tags as HTML
     */
    String getAuthorsAsHTML() {
		return null;
	}

    /**
     * Returns all authors of this blog as a list of HTML links.
     * @param resourceBundle <code>ResourceBundle</code> to use for translations
     * @return The tags as HTML
     */
    String getAuthorsAsHTML(ResourceBundle resourceBundle) {
		return null;
	}

    /**
     * Returns the page associated with this blog.
     * @return The page
     */
    Page getPage() {
		return null;
	}

    /**
     * Returns the resource associated with this blog entry.
     * @return The resource
     */
    Resource getResource() {
		return null;
	}

    /**
     * Returns the blog entry if the underlying page is a blog entry page, or <code>null</code> if it is a main blog
     * page.
     * @return The blog entry
     */
    BlogEntry getEntry() {
		return null;
	}

    /**
     * Returns whether the underlying resource is a blog entry.
     * @return <code>true</code> if the underlying resource is a blog entry, <code>false</code> otherwise
     */
    boolean isEntry() {
		return false;
	}

    /**
     * Returns whether the underlying resource is a blog archive, i.e. a page between the main blog page and the blog
     * entries.
     * @return <code>true</code> if the underlying resource is a blog archive, <code>false</code> otherwise
     */
    boolean isArchive() {
		return false;
	}

    /**
     * Returns the title of this blog.
     * @return The title
     */
    String getTitle() {
		return null;
	}

    /**
     * Sets the title of this blog.
     * @param title The title
     */
    void setTitle(String title) {
	}

    /**
     * Returns the description of this blog.
     * @return The description
     */
    String getDescription() {
		return null;
	}

    /**
     * Sets the description of this blog.
     * @param desc The description
     */
    void setDescription(String desc) {
	}

    /**
     * Returns the server-local URL of this blog, omitting scheme, server name and port number.
     * @return The URL
     */
    String getUrl() {
		return null;
	}

    /**
     * Returns the full URL of this blog, including scheme, server name and port.
     * @return The full URL
     */
    String getFullUrl() {
		return null;
	}

    /**
     * Returns the URL of the feed for this blog as absolute URL.
     * @return The feed URL
     */
    String getFeedUrl() {
		return null;
	}

    /**
     * Returns the URL of the feed for this blog.
     * @param absolute true if the URL should be absolute (http://server.com/blog), false if it should be relative
     *            (/blog)
     * @return The feed URL
     */
    String getFeedUrl(boolean absolute) {
		return null;
	}

    /**
     * Returns the URL for view of this blog. The value can be one of:
     * <ul>
     * <li>{@link Blog#VIEW_DEFAULT} (default)</li>
     * <li>{@link Blog#VIEW_EDIT}</li>
     * <li>{@link Blog#VIEW_SEARCH}</li>
     * <li>{@link Blog#VIEW_ARCHIVE}</li>
     * </ul>
     * @param view The view
     * @return The view URL
     */
    String getViewUrl(String view) {
		return null;
	}

    /**
     * Returns the URL where a new blog entry can be added, or <code>null</code> if not available.
     * @param request The request
     * @return The URL to add a new blog entry
     */
    String getAddEntryUrl(SlingHttpServletRequest request) {
		return null;
	}

    /**
     * Returns whether the blog contains any blog entries.
     * @return <code>true</code> if blog is empty, <code>false</code> otherwise
     */
    boolean isEmpty() {
		return false;
	}

    /**
     * Returns the archive for this blog. If no date format is passed, a default date format will be used.
     * @param max The maximum number of items (optional)
     * @param dateFormat The date format (optional)
     * @return The archive
     */
    BlogArchive getArchive(int max, DateFormat dateFormat) {
		return null;
	}

    /**
     * Returns an HTML list created from the archive of this blog. If no date format is passed, a default date format
     * will be used.
     * @param max The maximum number of items (optional)
     * @param dateFormat The date format (optional)
     * @return The archive as HTML
     */
    String getArchiveAsHTML(int max, DateFormat dateFormat) {
		return null;
	}

    /**
     * Returns an HTML list created from the archive of this blog. If no date format is passed, a default date format
     * will be used.
     * @param max The maximum number of items (optional)
     * @param dateFormat The date format (optional)
     * @param resourceBundle <code>ResourceBundle</code> to use for translations
     * @return The archive as HTML
     */
    String getArchiveAsHTML(int max, DateFormat dateFormat, ResourceBundle resourceBundle) {
		return null;
	}

    /**
     * Returns whether this blog has been modified and needs to be saved.
     * @see #save()
     * @return <code>true</code> if blog is modified, <code>false</code> otherwise
     */
    boolean isModified() {
		return false;
	}

    /**
     * Saves all changes made to this blog. In case the blog doesn't exist yet, it will be created.
     * @throws BlogException if saving fails
     */
    void save() throws BlogException {
	}

}
