/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.calendar.client.api;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * The Class AbstractCalendarConfiguration.
 */
public class AbstractCalendarConfiguration implements CalendarConfiguration {

    /** The is tagging allowed. */
    private final boolean isTaggingAllowed;

    /** The pn allow tagging. */
    String PN_ALLOW_TAGGING = "allowTagging";

    private final String[] tagFilterVal;

    String PN_TAG_FILTER = "taggingFilter";

    /**
     * Instantiates a new abstract calendar configuration.
     * @param resource the resource
     * @param cs the cs
     */
    public AbstractCalendarConfiguration(final Resource resource, final Resource parentResource) {
        final ValueMap propMap = parentResource.adaptTo(ValueMap.class);
        isTaggingAllowed = propMap.get(PN_ALLOW_TAGGING, false);
        tagFilterVal = propMap.get(PN_TAG_FILTER, String[].class);
    }

    /*
     * (non-Javadoc)
     * @see com.adobe.cq.social.calendar.client.api.CalendarConfiguration#isTaggingAllowed()
     */
    @Override
    @JsonProperty("isTaggingAllowed")
    public boolean isTaggingAllowed() {
		return false;
	}

    @Override
    public String getTagFilterVal() {
		return null;
	}

}
