/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/
package com.adobe.cq.social.calendar.client.api;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Calendar Paging information. A Calendar has a Next and Previous page.
 */
public class Page {
    private final String url;
    private final String suffix;
    private final String dateRange;
    private final Order order;

    /** Logger for this class. */
    private static final Logger LOG = LoggerFactory.getLogger(Page.class);

    public enum Order {
        PREVIOUS, NEXT
    };

    /**
     * Constructor
     * @param url
     * @param suffix
     * @param dateRange
     * @param order
     */
    public Page(final String url, final String suffix, final String dateRange, final Order order) {
        super();
        this.url = url;
        this.suffix = suffix;
        this.dateRange = dateRange;
        this.order = order;
    }

    /**
     * Get the URL of this page.
     * @return page url
     */
    public String getUrl() {
		return null;
	}

    /**
     * Get the pagination suffix of this page.
     * @return this page suffix
     */
    public String getSuffix() {
		return null;
	}

    /**
     * Get the date range of this page.
     * @return the date range of this page.
     */
    public String getDateRange() {
		return null;
	}

    /**
     * Get the order of this page
     * @return
     */
    public Order getOrder() {
		return null;
	}

}
