/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.calendar.client.endpoints;

import java.util.Map;

import javax.jcr.Session;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.calendar.client.api.CalendarEvent;
import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.SocialComponent;
import com.adobe.granite.security.user.UserProperties;

/**
 * Standard CRUD Operation used on a Calendar Event
 */
public interface CalendarOperations {
    /**
     * Create a new {@link CalendarEvent} base on the specified {@link SlingHttpServletRequest}.
     * @param request the client request
     * @return the new {@link Resource}
     * @throws OperationException if there is an error occurs
     */
    Resource createEvent(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Create an event for the specified Calendar resource.
     * @param target the target calendar resource.
     * @param up the author of the event
     * @param requestParams the properties of the new event.
     * @return the new {@link Resource}
     * @throws OperationException if an error occurs.
     */
    Resource createEvent(final Resource target, UserProperties up, final Map<String, Object> requestParams)
        throws OperationException {
		return null;
	}

    /**
     * Update a {@link CalendarEvent} base on the specified {@link SlingHttpServletRequest} using the specified.
     * {@link Session}.
     * @param request
     * @return the update event
     * @throws OperationException if there is an error occurs
     */
    Resource updateEvent(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Update a {@link CalendarEvent} base on the specified {@link SlingHttpServletRequest} using the specified.
     * {@link Session}.
     * @param target the target calendar resource.
     * @param up the author of the event
     * @throws OperationException if there is an error occurs
     */
    Resource updateEvent(final Resource target, UserProperties up, final Map<String, Object> requestParams)
        throws OperationException {
		return null;
	}

    /**
     * Delete a {@link CalendarEvent} base on the specified {@link SlingHttpServletRequest} using the specified.
     * {@link Session}.
     * @param request
     * @return the delete event
     * @throws OperationException if there is an error occurs
     */
    Resource deleteEvent(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Delete a {@link CalendarEvent} base on the specified {@link SlingHttpServletRequest} using the specified.
     * {@link Session}.
     * @param target the target calendar resource.
     * @return the delete event
     * @throws OperationException if there is an error occurs
     */
    Resource deleteEvent(final Resource target) throws OperationException {
		return null;
	}

    /**
     * Get the {@link SocialComponent} for the specified resource.
     * @param resource the resource
     * @param request the original request
     * @return the {@link SocialComponent}
     */
    public SocialComponent getSocialComponentForResource(final Resource resource,
        final SlingHttpServletRequest request) {
		return null;
	}
}
