/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.graph.client.api;

import com.adobe.cq.social.graph.Edge;
import com.adobe.cq.social.graph.SocialGraph;
import com.adobe.cq.social.graph.Vertex;
import com.adobe.cq.social.scf.SocialComponent;
import com.adobe.cq.social.scf.User;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;

public interface Following extends SocialComponent {
    String RESOURCE_TYPE = "social/socialgraph/components/hbs/following";
    String PROP_USERID = "userId";
    String PROP_FOLLOWEDID = "followedId";

    /**
     * Get the user
     */
    User getUser() {
		return null;
	}

    /**
     * Get the followed component. This could be a CommunityUser or other SocialComponent.
     */
    @JsonInclude(Include.NON_NULL)
    SocialComponent getFollowed() {
		return null;
	}

    /**
     * Indicate whether the current user can follow the specify following user.
     */
    boolean getMayFollow() {
		return false;
	}

    /**
     * Check the follow state
     */
    boolean getIsFollowed() {
		return false;
	}

    /**
     * Check if the followed item is a user
     */
    boolean getIsFollowedUser() {
		return false;
	}

    /**
     * Get socialGraph of this instance.
     * @return
     */
    SocialGraph socialGraph() {
		return null;
	}

    /**
     * Get the relationship representing this instance
     * @return
     */
    Edge edge() {
		return null;
	}

    /**
     * Get the user social graph node
     * @return
     */
    Vertex userNode() {
		return null;
	}

    /**
     * Get the followed user graph node
     * @return
     */
    Vertex followedNode() {
		return null;
	}
}
