/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.review.client.api;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.SyntheticResource;
import org.apache.sling.api.resource.ValueMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.comments.listing.CommentSocialComponentListProviderManager;
import com.adobe.cq.social.review.client.endpoints.ReviewOperations;
import com.adobe.cq.social.review.client.impl.ReviewCollectionSocialComponentImpl;
import com.adobe.cq.social.scf.ClientUtilities;
import com.adobe.cq.social.scf.QueryRequestInfo;
import com.adobe.cq.social.scf.SocialComponent;
import com.adobe.cq.social.scf.SocialComponentFactory;
import com.adobe.cq.social.scf.core.AbstractSocialComponentFactory;
import com.adobe.cq.social.ugc.api.UgcSearch;

/**
 * Social Comment Component Factory which allows the framework to create an {@link SocialComponent} for a Review
 * resource.
 */
@Component
@Service
public class ReviewCollectionSocialComponentFactory extends AbstractSocialComponentFactory implements
    SocialComponentFactory {

    @Reference
    private CommentSocialComponentListProviderManager listProviderManager;

    @Reference
    private UgcSearch search;
    /**
     * Logger.
     */
    private static final Logger LOG = LoggerFactory.getLogger(ReviewOperations.class);

    /**
     * Get the <code>SocialComponent</code> for the specified resource.
     * @param resource the <code>ReviewSystem</code> resource.
     * @return the target <code>SocialComponent</code>
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource) {
		return null;
	}

    /**
     * Get the <code>SocialComponent</code> for the specified resource and request.
     * @param resource the <code>ReviewSystem</code> resource
     * @param request the client request
     * @return the target <code>SocialComponent</code>
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource, final SlingHttpServletRequest request) {
		return null;
	}

    /**
     * @inheritDoc
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource, final ClientUtilities clientUtils,
        final QueryRequestInfo queryInfo) {
			return null;
		}

    /**
     * Get the supported resource type.
     * @return <code>ReviewSystem.RESOURCE_TYPE</code>
     */
    @Override
    public String getSupportedResourceType() {
		return null;
	}

}
