/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.scf;

import org.apache.commons.lang3.StringUtils;
import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.scf.ClientUtilities;
import com.adobe.cq.social.scf.CollectionPagination;
import com.adobe.cq.social.scf.SocialCollectionComponent;
import com.day.cq.wcm.api.Page;

/**
 * Shows information about the collection's pages.
 * @author mcweeney
 */
public class PageInfo {

    private final String urlPattern;
    private long totalItems = -1;
    private final CollectionPagination pagination;
    private final String params;
    private final String basePageURL;
    private final SocialCollectionComponent component;
    private final Resource includedResource;

    public PageInfo(final SocialCollectionComponent component, final ClientUtilities clientUtils,
        final CollectionPagination pagination) {
        this(component, clientUtils, pagination, null);
    }

    public PageInfo(final SocialCollectionComponent component, final ClientUtilities clientUtils,
        final CollectionPagination pagination, final String params) {
        this.pagination = pagination;
        final Page page = clientUtils.getContainingPage(component.getId().toString());
        if (page != null && !StringUtils.isEmpty(pagination.getSelectedIndex())) {
            basePageURL = clientUtils.externalLink(page.getPath() + ".index." + pagination.getSelectedIndex(), false);
        } else if (page != null) {
            basePageURL = clientUtils.externalLink(page.getPath(), false);
        } else {
            basePageURL = null;
        }
        urlPattern =
            clientUtils.externalLink(component.getId() + ClientUtilities.SOCO_SELECTOR, false) + "."
                    + "${startIndex}." + ((Long) this.getPageSize()).toString() + "."
                    + clientUtils.getRequestExtension();
        this.params = params;
        this.component = component;
        this.includedResource = clientUtils.getIncludedResource();
    }

    /**
     * Gets the url pattern for fetching other pages with two tokens ${startIndex} and ${size} which determine where
     * to start the next page from and how many entries to fetch.
     * @return a string with the format http://host:port/pathtocomponent.${startIndex}.${size}.selectors.format
     */
    public String getURLPattern() {
		return null;
	}

    /**
     * Gets the current page number.
     * @return the current page number
     */
    public long getSelectedPage() {
		return 0L;
	}

    /**
     * Gets the total number of pages in this component.
     * @return the total number of pages
     */
    public long getTotalPages() {
		return 0L;
	}

    /**
     * Gets the current configuration for the size of a page.
     * @return the size of a page in items
     */
    public long getPageSize() {
		return 0L;
	}

    /**
     * The current offset into the index that is being used for the pages.
     * @return the current index
     */
    public long getCurrentIndex() {
		return 0L;
	}

    /**
     * A simple function for getting the next page in the results. If it is the last page it points to this page.
     * @return a url for the next page
     */
    public String getNextPageURL() {
		return null;
	}

    /**
     * A simple function for getting the next page in the results.
     * @return a url for the previous page
     */
    public String getPreviousPageURL() {
		return null;
	}

    public String getNextSuffix() {
		return null;
	}

    public String getPreviousSuffix() {
		return null;
	}

    /**
     * The current offset into the index that is being used for the pages.
     * @return the current index
     */
    public String getSelectedIndex() {
		return null;
	}

    /**
     * Returns the base page URL based on the current social component.
     * @return a string that points to the path to the page that contains the component.
     */
    public String getBasePageURL() {
		return null;
	}

    public String getIncludedPath() {
		return null;
	}

    private long getTotalItems() {
		return 0L;
	}

    private long getNextOffset() {
		return 0L;
	}

    private long getPreviousOffset() {
		return 0L;
	}
}
