/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.granite.auth.cert;

/**
 * Main exception thrown by classes in this package. May either contain an error message or another exception wrapped inside.
 */
public class UserCertificateMappingException extends Exception {

    private static final long serialVersionUID = 2969569238110083303L;

    /**
     * Creates a <code>UserCertificateMappingException</code> given a message describing the failure cause.
     * 
     * @param message
     *            description message
     */
    public UserCertificateMappingException(String message) {
        super(message);
    }

    /**
     * Creates a <code>UserCertificateMappingException</code> given a message describing the failure cause and a failure cause.
     * 
     * @param message
     *            description message
     * @param cause
     *            root failure cause
     */
    public UserCertificateMappingException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Creates a <code>UserCertificateMappingException</code> given a failure cause.
     * 
     * @param cause
     *            root failure cause
     */
    public UserCertificateMappingException(Throwable cause) {
        super(cause);
    }
}
