/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.auth.saml.configuration;

import java.security.Key;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;

/**
 * Defines configuration information for the service provider.
 *
 * @author jasonhightower
 */
public class SpConfiguration {

    /**
     * String id that identifies the service provider with the identity provider.
     */
    private String entityId;

    /**
     * Use encryption for SAML Messages
     */
    private boolean useEncryption;

    /**
     * The alias of the SP's private key in the key-store of the 'authentication-service' system user.
     */
    private String spPrivateKeyAlias;

    /**
     * Key-store password of the 'authentication-service' system user
     */
    private char[] keyStorePassword;

    /**
     * Creates a new instance of SpConfiguration with the given KeyProvider.
     */
    public SpConfiguration() {
        super();
    }

    /**
     * Sets the id that identifies the service provider with the identity provider.
     *
     * @param entityId String containing the service provider id.
     */
    public void setEntityId(final String entityId) {
	}

    /**
     * Gets the id that identifies the service provider with the identity provider.
     *
     * @return String containing the service provider id.
     */
    public String getEntityId() {
		return null;
	}

    /**
     * Gets the private Key used to decrypt saml messages.
     *
     * @param keyStore KeyStore bound to 'authentication-service' user to retrieve SP's private key
     * @return Key used to decrypt saml messages.
     */
    public Key getDecryptionKey(KeyStore keyStore) {
		return null;
	}

    public boolean getUseEncryption() {
		return false;
	}

    public void setUseEncryption(boolean useEncryption) {
	}

    public void setSpPrivateKeyAlias(final String spPrivateKeyAlias) {
	}

    public void setKeyStorePassword(final String keyStorePassword) {
	}
}
