/*
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 */

package com.adobe.granite.contexthub.api;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.granite.contexthub.impl.ClientLib;
import com.adobe.granite.contexthub.impl.Constants;

public class Mode {
    private boolean enabled;

    private String name;

    private String resourceType;

    private ValueMap properties;

    private Resource resource;

    private String path;

    /**
     * Constructs a module with properties from the given resource.
     *
     * @param resource resource
     */
    public Mode(Resource resource) {
        this.resource = resource;
        path = resource.getPath();
        properties = ResourceUtil.getValueMap(resource);
        enabled = properties.get("enabled", true);
        name = properties.get("modeType", String.class);
        resourceType = resource.getResourceType();
    }

    /**
     * Whether this module should be enabled or not.
     *
     * @return {@code true} if this module should be enabled
     */
    public boolean isEnabled() {
		return false;
	}

    /**
     * Get the name of this module.
     *
     * @return name
     */
    public String getName() {
		return null;
	}

    /**
     * Get the resourceType of this module.
     *
     * @return resourceType
     */
    public String getResourceType() {
		return null;
	}

    /**
     * Get all properties of this module.
     *
     * @return properties
     */
    public ValueMap getProperties() {
		return null;
	}

    /**
     * Get the resource which describes this module.
     *
     * @return resource
     */
    public Resource getResource() {
		return null;
	}

    /**
     * Get the path where this module is defined.
     *
     * @return path
     */
    public String getPath() {
		return null;
	}

    /**
     * Get the clientlib categories that should be included for this module.
     *
     * @return clientlib categories
     */
    public List<String> getCategories() {
		return null;
	}
}
