/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.maintenance;

import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;

import org.apache.sling.api.resource.Resource;
import org.quartz.CronExpression;

import com.adobe.granite.maintenance.impl.MaintenanceWindowImpl;

/**
 * Utility class for maintenance related stuff.
 */
public abstract class MaintenanceUtil {

    /**
     * Check if the start and the end time are valid time definitions ([hour]:[minute]).
     * This method does not check whether startTime is lower than endTime.
     */
    public static boolean isValidTimeInterval(final String startTime, final String endTime) {
		return false;
	}

    /**
     * Check if the given time string is valid ([hour]:[minute])
     * @return a two value array with hour and minute if its valid, <code>null</code> otherwise.
     */
    public static int[] parseTime(final String value) throws IllegalArgumentException {
		return null;
	}

    public static String getCronExpression(final int[] timeDef) {
		return null;
	}

    public static String getCronExpression(final String time) {
		return null;
	}

    /**
     * Return the next execution time for this window.
     * If the current time is currently within the window, null will be returned.
     * If the time definitions are invalid, null is returned as well.
     * @param startTime
     * @param endTime
     * @return The next execution time, if the window is currently open
     */
    public static Calendar getNextExecutionTime(final String startTime, final String endTime) {
		return null;
	}

    /**
     * Return the next execution time for this maintenance task
     * If the time definitions are invalid, null is returned.
     * @return The next execution time, if the window is valid
     */
    public static Calendar getNextExecutionTime(final MaintenanceTaskInfo.TaskSchedule schedule,
                                                final String startTime) {
													return null;
												}

    /**
     * Return the next execution time for this window.
     * If the current time is currently within the window, null will be returned.
     * If the time definitions are invalid, null is returned as well.
     * @param windowResource The window resource.
     * @return The next execution time, if the window is currently open
     * @since 1.1
     */
    public static Calendar getNextWindowExecutionTime(final Resource windowResource) {
		return null;
	}
}
