/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.oauth.server;

import javax.servlet.http.HttpServletRequest;
import org.apache.jackrabbit.api.security.user.User;

/**
 * The <code>Scope</code> provides a simple API to 
 * handle scopes 
 */
public interface Scope {
    
    /**
     * Get the scope name
     * 
     * @return the scope name
     */
    public String getName() {
		return null;
	}
    
    /**
     * Get the resource path associated with the scope
     * 
     * @param user The authenticated user
     * @return The resource path associated to the scope
     */
    public String getResourcePath(User user) {
		return null;
	}
    
    /**
     * Get the endpoint associated with the scope
     * 
     * @return the endpoint associated to the scope
     */
    public String getEndpoint() {
		return null;
	}
    
    /**
     * Get the scioe description
     * 
     * @param request The HttpServletRequest request
     * @return the scope description
     */
    public String getDescription(HttpServletRequest request) {
		return null;
	}
}
