/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *************************************************************************/
package com.adobe.granite.ocs.api;

import aQute.bnd.annotation.ProviderType;
import org.apache.sling.api.resource.Resource;

/**
 * The environment status provides access to the general status information of an environment.
 */
@ProviderType
public interface EnvironmentStatus extends Resource {

    /**
     * The environment status.
     *
     * @return The current status of an environment.
     */
    public Status getStatus() {
		return null;
	}

    /**
     * Get the currently running goal.
     *
     * @return The currently running goal.
     */
    public String getCurrentGoal() {
		return null;
	}

    /**
     * Get all previous goals.
     *
     * @return The previous goals.
     */
    public String[] getGoals() {
		return null;
	}

    public String getFailReason() {
		return null;
	}


    /**
     * All the available environment status.
     */
    public enum Status {
        NEW,
        LC_IN_PROGRESS,
        LC_FAILED,
        LC_FINISHED
    }

}
