/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *************************************************************************/
package com.adobe.granite.ocs.api;

import aQute.bnd.annotation.ProviderType;
import org.apache.sling.api.resource.Resource;

/**
 * The OCS host.
 * <p/>
 * The OCS host is associated to an {@link com.adobe.granite.ocs.api.Environment environment}.
 */
@ProviderType
public interface Host extends Resource {

    /**
     * Gives access to the host title.
     *
     * @return The host title.
     */
    public String getTitle() {
		return null;
	}

    /**
     * Gives access to the host description.
     *
     * @return The host description.
     */
    public String getDescription() {
		return null;
	}

    /**
     * Gives access to the OCS environment this host belongs to.
     *
     * @return The {@link com.adobe.granite.ocs.api.Environment environment} this host belongs to.
     */
    public Environment getEnvironment() {
		return null;
	}

    /**
     * Get the host's fully qualified domain name.
     *
     * @return The host's fully qualified domain name.
     */
    public String getFQDN() {
		return null;
	}

    /**
     * Get the host's URL.
     *
     * @return the host's URL.
     */
    public String getURL() {
		return null;
	}

    /**
     * Host properties.
     */
    public enum Properties {

        HOST_NAME("host_name"),
        HOST_FQDN("host_fqdn"),
        SSH_KEY("ssh_key"),
        SSH_KEY_NAME("ssh_key_name");

        private String propertyName = null;

        Properties(String propertyName) {
            this.propertyName = propertyName;
        }

        public String propertyName() {
            return this.propertyName;
        }
    }

}
