/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *************************************************************************/

package com.adobe.granite.ocs.api;

import aQute.bnd.annotation.ProviderType;
import com.adobe.granite.ocs.api.provider.Provider;
import org.apache.sling.api.resource.ValueMap;

import java.util.List;

/**
 * The OCS manager.
 * <p/>
 * The OCS manager is the main entry point for working with the OCS model. You can get an instance of the OCS manager by
 * adapting a {@link org.apache.sling.api.resource.ResourceResolver resource resolver} to this class.
 */
@ProviderType
public interface OCSManager {

    /**
     * Get a listing of all the available tenants.
     *
     * @return List of {@link com.adobe.granite.ocs.api.Tenant tenants} or an empty list if no tenants are found.
     */
    public List<Tenant> getTenants() {
		return null;
	}

    /**
     * Create a new tenant according to the given tenant properties.
     *
     * @param tenantProperties The properties to use to create the new tenant.
     *
     * @return The new {@link com.adobe.granite.ocs.api.Tenant tenant}.
     */
    public Tenant createTenant(ValueMap tenantProperties) {
		return null;
	}

    /**
     * @param tenant
     * @param deploymentProperties
     *
     * @return
     */
    public Deployment createDeployment(Tenant tenant, ValueMap deploymentProperties, ValueMap providerProperties, Provider providerTemplate, Deployment deploymentTemplate) {
		return null;
	}

    /**
     * Start a new deployment process for the given environment.
     */
    public Environment deploy(Environment environment) {
		return null;
	}

    /**
     * Start the the un-deployment process for the given environment.
     *
     * @param environment The environment to un-deploy.
     *
     * @return The environment being un-deployed.
     */
    public Environment unDeploy(Environment environment) {
		return null;
	}

    public void lifeCycleStart(Environment environment, String lifecycle) {
	}

    public void lifeCycleNext(Environment environment, String currentGoal) {
	}

    public void lifeCycleFailed(Environment environment, String currentGoal, String reason) {
	}

    public void deleteDeployment(Deployment deployment) {
	}

    public void deleteTenant(Tenant tenant) {
	}
}
