/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *************************************************************************/

package com.adobe.granite.ocs.api;

import aQute.bnd.annotation.ProviderType;
import com.adobe.granite.ocs.api.provider.Provider;
import org.apache.sling.api.resource.Resource;

import java.util.List;

/**
 * The OCS tenant.
 *
 * The OCS tenant is the root of the OCS model. The {@link com.adobe.granite.ocs.api.OCSManager OCS manager} can give
 * you a list of all available tenants. Further, if you have access to an OCS tenant resource, the resource can be
 * adapted to a tenant.
 */
@ProviderType
public interface Tenant extends Resource {

    /**
     * Gives access to the tenant title.
     *
     * @return The tenant title.
     */
    public String getTitle() {
		return null;
	}

    /**
     * Gives access to the tenant description.
     *
     * @return The tenant description.
     */
    public String getDescription() {
		return null;
	}

    /**
     * Get a listing of the deployments of this tenant.
     *
     * @return List of {@link com.adobe.granite.ocs.api.Deployment deployments} or empty list, if the tenant does not
     * have any deployments.
     */
    public List<Deployment> getDeployments() {
		return null;
	}

    /**
     * Get a listing of the deployment templates of this tenant.
     *
     * @return List of {@link com.adobe.granite.ocs.api.Deployment deployment templates} or empty list, if the tenant
     * does not have any deployment templates.
     */
    public List<Deployment> getDeploymentTemplates() {
		return null;
	}

    /**
     * Get a listing of the provider templates of this tenant.
     *
     * @return List of {@link com.adobe.granite.ocs.api.provider.Provider provider templates} or empty list, if the
     * tenant does not have any provider templates.
     */
    public List<Provider> getProviderTemplates() {
		return null;
	}

}
