/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ocs.api.goals;

import aQute.bnd.annotation.ProviderType;
import com.adobe.granite.ocs.api.Environment;
import com.adobe.granite.ocs.api.OCSConfig;
import com.adobe.granite.ocs.api.OCSException;
import com.adobe.granite.ocs.api.OCSManager;
import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.event.jobs.Job;
import org.apache.sling.event.jobs.consumer.JobConsumer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jcr.Session;
import java.util.HashMap;
import java.util.Map;

/**
 * The Abstractgoal is a convenience abstract implementation for {@link com.adobe.granite.ocs.api.goals.Goal}
 * implementations. It implements the job's process method and aggregates information vital to a Goal, such as the
 * resource resolver and the environment.
 */
@ProviderType
@Deprecated
public abstract class AbstractGoal implements JobConsumer, Goal {

    private final Logger log = LoggerFactory.getLogger(this.getClass());

    private ResourceResolverFactory resolverFactory = null;

    private OCSConfig ocsConfig = null;

    private boolean async;

    public JobResult process(Job job) {
		return null;
	}

    protected void bindOcsConfig(OCSConfig ocsConfig){
	}

    protected void unbindOcsConfig(OCSConfig ocsConfig){
	}

    protected void bindResolverFactory(ResourceResolverFactory resolverFactory){
	}

    protected void unbindResolverFactory(ResourceResolverFactory resolverFactory){
	}

    /**
     * Attempts to read the environment path from the job payload.
     */
    protected String getEnvironmentPath(Job job) throws OCSException {
		return null;
	}

    protected Environment getEnvironment(ResourceResolver resolver, String environmentPath) throws OCSException {
		return null;
	}

    protected ResourceResolver getResourceResolver() throws LoginException, OCSException {
		return null;
	}

    protected void setAsync(boolean async) {
	}

    protected OCSConfig getOcsConfig() {
		return null;
	}

    public abstract void run(Job job, Environment environment, ResourceResolver resolver) throws OCSException {
	}
}
