/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ocs.api.goals;

import com.adobe.granite.ocs.api.Environment;
import com.adobe.granite.ocs.api.OCSException;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.event.jobs.Job;

/**
 * A Goal is a runnable job in the context of the One-Click-Setup lifecycle of an {@link com.adobe.granite.ocs.api.Environment}.
 */
@Deprecated
public interface Goal {

    /**
     * This method is executed by {@link com.adobe.granite.ocs.api.goals.AbstractGoal} once an environment is subject
     * to the One-Click-Setup lifecycle.
     *
     * @param job         The {@link org.apache.sling.event.jobs.Job} that represents the lifecycle.
     * @param environment The {@link com.adobe.granite.ocs.api.Environment} which is the payload of the lifecycle.
     * @param resolver    The {@link org.apache.sling.api.resource.ResourceResolver} with which to access the repository.
     *
     * @throws com.adobe.granite.ocs.api.OCSException when the goal encounters an error condition.
     */
    void run(Job job, Environment environment, ResourceResolver resolver) throws OCSException {
	}
}
