/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *************************************************************************/
package com.adobe.granite.ocs.api.provider;

import aQute.bnd.annotation.ProviderType;

/**
 * Defines provider staus.
 */
@ProviderType
public interface ProviderStatus {

    /**
     * Get the deployment id.
     *
     * A deployment id uniquely identifies an environment in the cloud as per provider implementation.
     *
     * @return The deployment id.
     */
    public String getDeploymentId() {
		return null;
	}

    /**
     * Get the environment this status relates to.
     *
     * @return The environment this status belongs to.
     */
    public String getEnvironment() {
		return null;
	}

    /**
     * Get the provider status.
     *
     * @return The current provider status of an environment.
     */
    public Status getStatus() {
		return null;
	}

    /**
     * Available provider status.
     */
    public enum Status {
        CREATE_IN_PROGRESS,
        CREATED,
        CREATE_FAILED,
        DELETE_IN_PROGRESS,
        DELETE_FAILED,
        DELETED,
        GET_STATUS_FAILED,
        PUBKEY_IMPORTED,
        PUBKEY_IMPORT_FAILED,
        PUBKEY_UNREGISTERED,
        PUBKEY_UNREGISTER_FAILED
    }
}
