/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.requests.logging.api;

/**
 * The <code>RequestLogger</code> class provides the functionality to gather
 * requests. This service is exposed in the context of the
 * {@link com.adobe.granite.requests.logging} bundle.
 */
public interface RequestLogger {
    /**
     * Gets a list of the longest requests captured by the system.
     * @return a TimedRequest array of the longest requests, ordered in descending
     * order by the solve time.
     */
    public TimedRequest[] getLongestRequests() {
		return null;
	}

    /**
     * Gets a list of the requests captured by the system in the current time frame.
     * @return a TimedRequest array of the requests logged in the current time frame,
     * ordered in ascending order by the time when the request was received.
     * A time frame is an arbitrary period of time configured by the user of this service.
     * I.e.: the default value is a time frame of 60 minutes, so the requests received in the past
     * 60 minutes will be returned by this method.
     */
    public TimedRequest[] getTimeFrameRequests() {
		return null;
	}
}
