/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.translation.api;

import java.util.Map;

/** The TranslationScope provides scope, word count, size, for a TranslationObject or collection of TranslationObjects */
public interface TranslationScope {

    /**
     * Gets a word count of the total number of words to be translated.
     * @return the number of words
     */
    int getWordCount() {
		return 0;
	}

    /**
     * Gets the number of images.
     * @return the number of images
     */
    int getImageCount() {
		return 0;
	}

    /**
     * Gets the number of videos.
     * @return the number of videos
     */
    int getVideoCount() {
		return 0;
	}

    /**
     * Gets the final scope. 
     * ICE Match - 90.85% 
     * 100% match - 4.04% 
     * 100-95% match - 0% 
     * 95-75% match - 0% 
     * 75-0% match - 5.1% 
     * Repetition - 0% 
     * Cost - 63.96 USD
     * @return the percentage
     */
    Map<String, String> getFinalScope() {
		return null;
	}
}
