/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import javax.servlet.http.HttpServletResponse;

import org.apache.sling.servlets.post.AbstractPostResponse;

import com.adobe.granite.i18n.LocaleUtil;
import com.adobe.granite.xss.XSSAPI;
import com.day.cq.i18n.I18n;

/**
 * The post response which produces HTML containing metadata, such as status code, title, so that the client can parse
 * it.
 */
public class HtmlResponse extends AbstractPostResponse {
    private static final String PN_DESCRIPTION = "description";

    private final XSSAPI xss;

    private final I18n i18n;

    private final Locale locale;

    private final List<Change> changes = new ArrayList<Change>();

    private final List<Link> links = new ArrayList<Link>();

    public HtmlResponse(XSSAPI xss, I18n i18n, Locale locale) {
        this.xss = xss;
        this.i18n = i18n;
        this.locale = locale;
    }

    public void onModified(String path) {
	}

    public void onCreated(String path) {
	}

    public void onDeleted(String path) {
	}

    public void onMoved(String srcPath, String dstPath) {
	}

    public void onCopied(String srcPath, String dstPath) {
	}

    public void onChange(String type, String... arguments) {
	}

    public void setDescription(String description) {
	}

    /**
     * Sets the general purpose error message using the given status code. The title and description will be set
     * automatically.
     * @param code the status code
     */
    public void setGeneralError(int code) {
	}

    /**
     * Adds a redirect link to indicate where the client should go after the post. Note that you SHOULD call this method
     * once, otherwise would be a duplicate.
     * @param href the link
     * @param text the link text
     */
    public void addRedirectLink(String href, String text) {
	}

    /**
     * Adds a link to the response. It is for the server to give affordance to the client.
     * @param rel relationship attribute
     * @param href the link
     * @param text the link text
     */
    public void addLink(String rel, String href, String text) {
	}

    @Override
    protected void doSend(HttpServletResponse res) throws IOException {
	}

    private void writeDefinition(Writer out, String rel, String term, Object value) throws IOException {
	}

    private void writeChange(Writer out, Change change) throws IOException {
	}

    private void writeLink(Writer out, Link link) throws IOException {
	}

    private void write(Writer out, String tag, String text, boolean newline) throws IOException {
	}

    private class Change {
        String type;

        String[] arguments;

        public Change(String type, String... arguments) {
            this.type = type;
            this.arguments = arguments;
        }
    }

    private class Link {
        String rel;

        String href;

        String text;

        public Link(String rel, String href, String text) {
            this.rel = rel;
            this.href = href;
            this.text = text;
        }
    }
}
