/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Set;

import javax.servlet.http.Cookie;

import org.apache.sling.api.SlingHttpServletRequest;

/**
 * A key-value map of client-side state. A client may set a state such that the
 * server can retrieve it to do something specific about this client based on
 * the state.
 */
public class State {
    private SlingHttpServletRequest request;
    private Set<String> names;

    public State(SlingHttpServletRequest request) {
        this.request = request;
    }

    /**
     * Returns the item value of the given name. Returns <code>null</code> if the
     * item is not found.
     * @param name the name of the item
     * @return the item value as a string
     */
    public String get(String name) {
		return null;
	}

    /**
     * Returns the item value of the given name. Returns the given defaultValue if
     * the item is not found.
     * @param name the name of the item
     * @param defaultValue the default value
     * @return the item value as a string or the default value if the item is not found
     */
    public String get(String name, String defaultValue) {
		return null;
	}

    /**
     * Returns the item value of the given name. Returns the given defaultValue if
     * the item is not found, or the value is not a boolean string ("true" or "false").
     * @param name the name of the item
     * @param defaultValue the default value
     * @return the item value as a boolean or the default value if the value is not a
     * boolean string
     */
    public boolean get(String name, boolean defaultValue) {
		return false;
	}

    /**
     * Returns the item value of the given name. Returns the given defaultValue if
     * the item is not found, or the value is not an integer string.
     * @param name the name of the item
     * @param defaultValue the default value
     * @return the item value as an int or the default value if the value is not an
     * int
     */
    public int get(String name, int defaultValue) {
		return 0;
	}
    
    /**
     * Returns the available names.
     * @return the available names 
     */
    public Iterator<String> names() {
		return null;
	}
    
    /**
     * Returns the state item with the given name. Returns <code>null</code> if the
     * item is not found.
     * @param name the name of the item
     * @return the state item
     */
    public Item getItem(String name) {
		return null;
	}
    
    /**
     * An item in the state.
     */
    public interface Item {
        /**
         * Returns the name of the item.
         * @return the name of the item
         */
        String getName() {
			return null;
		}
        
        /**
         * Returns the value as string.
         * @return the value as string
         */
        String getString() {
			return null;
		}
        
        /**
         * Returns the value as boolean.
         * The conversion is following {@link Boolean#parseBoolean(String)} semantic.
         * @return the value as boolean
         */
        boolean getBoolean() {
			return false;
		}
        
        /**
         * Returns the value as int.
         * The conversion is following {@link Integer#parseInt(String)} semantic.
         * @return the value as int
         */
        int getInt() throws NumberFormatException {
			return 0;
		}
    }
    
    private class ItemImpl implements Item {
        private String name;
        private String value;

        public ItemImpl(String name, String value) {
            this.name = name;
            this.value = value;
        }
        
        public String getName() {
			return null;
		}

        public String getString() {
			return null;
		}

        public boolean getBoolean() {
			return false;
		}

        public int getInt() throws NumberFormatException {
			return 0;
		}
    }
}
