/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.granite.workflow.exec;

import java.util.Date;

/**
 * Defines an item which is available in the workflow inbox
 */
public interface InboxItem {

    /**
     * Returns the unique identifier for this InboxItem
     * @return the ID
     */
    String getId() {
		return null;
	}

    /**
     * Returns the current assignee, respectively the info in which
     * inbox the InboxItem "resides".
     *
     * @return current assignee
     */
    String getCurrentAssignee() {
		return null;
	}

    /**
     * Returns the start time of the <code>InboxItem</code>.
     *
     * @return The start time of the <code>InboxItem</code>.
     */
    Date getTimeStarted() {
		return null;
	}

    /**
     * Returns the end time of the <code>InboxItem</code>.
     *
     * @return The end time of the <code>InboxItem</code>.
     */
    Date getTimeEnded() {
		return null;
	}

    /**
     * Returns the status of the <code>InboxItem</code>.
     *
     * @return the status of the InboxItem
     */
    Status getStatus() {
		return null;
	}

    /**
     * Returns the type of this InboxItem.  Different implementations of InboxItem should return unique values
     * @return the item type
     */
    String getItemType() {
		return null;
	}

    /**
     * Returns the subtype of this InboxItem.
     * @return the subtype of this item, or null if there is no subtype.
     */
    String getItemSubType() {
		return null;
	}
}
