/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.reef.siren;

import java.util.LinkedList;
import java.util.List;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * An {@code Action} is a behavior that is exposed from an {@link Entity}.
 */
public final class Action {

    private String name;

    private String[] clazz;

    private Method method;

    private String href;

    private String title;

    private String type;

    private List<Field> fields = new LinkedList<Field>();

    /**
     * Constructs a new Action.
     * 
     * @param name
     * @param href
     * @throws IllegalArgumentException
     */
    public Action(String name, String href) throws IllegalArgumentException {
        if (name == null || name.isEmpty() || href == null || href.isEmpty()) {
            throw new IllegalArgumentException("name and href can not be null or empty.");
        }
        this.name = name;
        this.href = href;
    }

    /**
     * Returns the name attribute.
     * 
     * @return the name
     */
    public String getName() {
		return null;
	}

    /**
     * Sets the name attribute.
     * 
     * @param name the name to set
     */
    public void setName(String name) {
	}

    /**
     * Returns the class attribute.
     * 
     * @return the clazz
     */
    public String[] getClazz() {
		return null;
	}

    /**
     * Sets the class attribute.
     * 
     * @param clazz the clazz to set
     */
    public void setClazz(String[] clazz) {
	}

    /**
     * Returns the method attribute.
     * 
     * @return the method
     */
    public Method getMethod() {
		return null;
	}

    /**
     * Sets the method attribute.
     * 
     * @param method the method to set
     */
    public void setMethod(Method method) {
	}

    /**
     * Returns the href attribute.
     * 
     * @return the href
     */
    public String getHref() {
		return null;
	}

    /**
     * Sets the href attribute.
     * 
     * @param href the href to set
     */
    public void setHref(String href) {
	}

    /**
     * Returns the title attribute.
     * 
     * @return the title
     */
    public String getTitle() {
		return null;
	}

    /**
     * Sets the title attribute.
     * 
     * @param title the title to set
     */
    public void setTitle(String title) {
	}

    /**
     * Returns the type attribute.
     * 
     * @return the type
     */
    public String getType() {
		return null;
	}

    /**
     * Sets the type attribute.
     * 
     * @param type the type to set
     */
    public void setType(String type) {
	}

    /**
     * Returns the fields.
     * 
     * @return the fields
     */
    public List<Field> getFields() {
		return null;
	}

    /**
     * Sets the fields.
     * 
     * @param fields the fields to set
     */
    public void setFields(List<Field> fields) {
	}

    /**
     * Adds a field
     * 
     * @param field the field to add
     */
    public void addField(Field field) {
	}

    @Override
    public String toString() {
		return null;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    @Override
    public boolean equals(Object obj) {
		return false;
	}

    public enum Method {
        DELETE, 
        GET, 
        PATCH, 
        POST, 
        PUT;
    }

}
