/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.reef.siren;

import java.util.Arrays;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * A {@link Link} represents a navigational transition.
 */
public final class Link {

    private String[] rel;

    private String href;

    private String title;

    private String type;

    /**
     * Constructs a new Link.
     * 
     * @param rel
     * @param href
     * @throws IllegalArgumentException if either {@code rel} or {@code href}
     *             are {@code null} or empty.
     */
    public Link(String[] rel, String href) throws IllegalArgumentException {
        if (rel == null || rel.length == 0 || href == null || href.isEmpty()) {
            throw new IllegalArgumentException("rel and href can not be null or empty");
        }
        this.rel = rel;
        this.href = href;
    }

    /**
     * Returns the rel attribute.
     * 
     * @return
     */
    public String[] getRel() {
		return null;
	}

    /**
     * Sets the rel attribute.
     * 
     * @param rel
     */
    public void setRel(String[] rel) {
	}

    /**
     * Returns the href attribute.
     * 
     * @return
     */
    public String getHref() {
		return null;
	}

    /**
     * Sets the href attribute.
     * 
     * @param href
     */
    public void setHref(String href) {
	}

    /**
     * Returns the title attribute.
     * 
     * @return
     */
    public String getTitle() {
		return null;
	}

    /**
     * Sets the title attribute.
     * 
     * @param title
     */
    public void setTitle(String title) {
	}

    /**
     * Returns the type attribute.
     * 
     * @return
     */
    public String getType() {
		return null;
	}

    /**
     * Sets the type attribute.
     * 
     * @param type
     */
    public void setType(String type) {
	}

    @Override
    public String toString() {
		return null;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    @Override
    public boolean equals(Object obj) {
		return false;
	}

}
