// =================================================================================================
// ADOBE SYSTEMS INCORPORATED
// Copyright 2012 Adobe Systems Incorporated
// All Rights Reserved
//
// NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the terms
// of the Adobe license agreement accompanying it.
// =================================================================================================

package com.adobe.xmp.core.serializer;

import com.adobe.xmp.core.XMPException;


/**
 * This exception is thrown if the data model contains portions that can't be serialized 
 * by a specific serializer or if the options are inconsistent.
 */
@SuppressWarnings("serial")
public class SerializeXMPException extends XMPException
{

	/**
	 * @see XMPException#XMPException(String)
	 */
	public SerializeXMPException(String errorMsg)
	{
		super(errorMsg);
	}

}
