// =================================================================================================
// ADOBE SYSTEMS INCORPORATED
// Copyright 2011 Adobe Systems Incorporated
// All Rights Reserved
//
// NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the terms
// of the Adobe license agreement accompanying it.
// =================================================================================================

package com.adobe.xmp.schema.model.rules;

import java.util.ArrayList;
import java.util.List;

import com.adobe.xmp.schema.model.SchemaVisitor;
import com.adobe.xmp.schema.model.TypeRule;
import com.adobe.xmp.schema.model.XMPSchemaException;
import com.adobe.xmp.schema.model.SimpleType.BasicType;
import com.adobe.xmp.schema.model.rules.Vocable.Type;


/**
 * The rule covers the XMP types "closed choice".
 * An arbitrary number of vocabulary can be added.
 * 
 * @author Stefan Makswit
 */
public class ClosedChoice implements TypeRule
{
	private static final long serialVersionUID = 1L;
	/** List of allowed vocabulary */
	private ArrayList<Vocable> vocabulary = new ArrayList<Vocable>();
	/** the type of vocabulary */
	private Type vocablularyType;
	
	
	/**
	 * Constructor gets the type information of the Vocabulary.
	 */
	public ClosedChoice(Vocable.Type vocablularyType)
	{
		this.vocablularyType = vocablularyType;
	}
	
	
	/**
	 * Add a vocable.
	 * 
	 * @param xmpValue the XMP value, usually a String,
	 * 		but in some cases it can also be of another type.
	 * @param label the display label for the vocable.
	 * @throws XMPSchemaException Throws an exception if a vocable with the wrong type is added
	 */
	public void addVocable(Object xmpValue, String label) throws XMPSchemaException
	{
	}
	
	
	/**
	 * Adds a vocable.
	 * 
	 * @param vocable a Vocable
	 * @throws XMPSchemaException Throws an exception if a vocable with the wrong type is added
	 */
	public void addVocable(Vocable vocable) throws XMPSchemaException
	{
	}

	
	/**
	 * @return Returns all vocabulary.
	 */
	public List<Vocable> getVocabulary()
	{
		return null;
	}

	
	/**
	 * @see com.adobe.xmp.schema.model.TypeRule#accept(com.adobe.xmp.schema.model.SchemaVisitor)
	 */
	public void accept(SchemaVisitor schemaVisitor) throws XMPSchemaException
	{
	}
	
	
	/**
	 * @param xmpValue
	 * @throws XMPSchemaException 
	 */
	private void checkType(Object xmpValue) throws XMPSchemaException
	{
	}
}
