/*
 * Copyright 1997-2011 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.activitystreams.api;

import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;

import java.util.Collection;

/**
 * <code>Activity</code> represents a user activity object.
 * @deprecated Use {@link com.adobe.granite.activitystreams.Activity} instead.
 */
public interface Activity {

    /**
     * Gets the title
     *
     * @return The title
     */
    public String getTitle() {
		return null;
	}

    /**
     * Sets the title
     *
     * @param title The new title
     * @return The updated <code>Activity</code>
     */
    public Activity setTitle(String title) {
		return null;
	}

    /**
     * Gets the description
     *
     * @return The description
     */

    public String getDescription() {
		return null;
	}

    /**
     * Sets the description
     *
     * @param description The new description
     * @return The updated <code>Activity</code>
     */
    public Activity setDescription(String description) {
		return null;
	}

    /**
     * Gets the content
     *
     * @return The content
     */
    public String getContent() {
		return null;
	}

    /**
     * Sets the content
     *
     * @param content The new content
     * @return The updated <code>Activity</code>
     */
    public Activity setContent(String content) {
		return null;
	}

    /**
     * Gets the verb
     *
     * @return The verb
     */
    public String getVerb() {
		return null;
	}

    /**
     * Sets the verb
     *
     * @param verb The new verb
     * @return The updated <code>Activity</code>
     */
    public Activity setVerb(String verb) {
		return null;
	}

    /**
     * Gets the link
     *
     * @return The link
     */
    public String getLink() {
		return null;
	}

    /**
     * Sets the link
     *
     * @param link The new link
     * @return The updated <code>Activity</code>
     */
    public Activity setLink(String link) {
		return null;
	}

    /**
     * Gets the streamName
     *
     * @return The streamName
     */
    public String getStreamName() {
		return null;
	}

    /**
     * Sets the streamName
     *
     * @param streamName The new streamName
     * @return The updated <code>Activity</code>
     */
    public Activity setStreamName(String streamName) {
		return null;
	}

    /**
     * Gets the noCache
     *
     * @return The noCache
     */
    public String getNoCache() {
		return null;
	}

    /**
     * Sets the noCache
     *
     * @param noCache The new noCache
     * @return The updated <code>Activity</code>
     */
    public Activity setNoCache(String noCache) {
		return null;
	}

    /**
     * Gets the created
     *
     * @return The created
     */
    public Long getCreated() {
		return null;
	}

    /**
     * Sets the created
     *
     * @param created The new created
     * @return The updated <code>Activity</code>
     */
    public Activity setCreated(Long created) {
		return null;
	}

    /**
     * Gets the createdBy
     *
     * @return The createdBy
     */
    public String getCreatedBy() {
		return null;
	}

    /**
     * Sets the createdBy
     *
     * @param createdBy The new createdBy
     * @return The updated <code>Activity</code>
     */
    public Activity setCreatedBy(String createdBy) {
		return null;
	}

    /**
     * Gets the <code>ActivityObject</code> of the activity
     *
     * @return The objects
     */
    public Collection<ActivityObject> getObjects() {
		return null;
	}

    /**
     * Adds an <code>ActivityObject</code>
     *
     * @param obj The <code>ActivityObject</code> to add
     * @return The updated <code>Activity</code>
     */
    public Activity addObject(ActivityObject obj) {
		return null;
	}

    /**
     * Gets the <code>ActivityTarget</code> of the activity
     *
     * @return The objects
     */
    public Collection<ActivityTarget> getTargets() {
		return null;
	}

    /**
     * Adds an <code>ActivityTarget</code>
     *
     * @param obj The <code>ActivityTarget</code> to add
     * @return The updated <code>Activity</code>
     */
    public Activity addTarget(ActivityTarget obj) {
		return null;
	}

    /**
     * Gets the property value based on a property name (generic getter).
     * @param name The name of the property
     * @return The property value. Null if property does not exist.
     */
    public String getProperty(String name) {
		return null;
	}

    /**
     * Sets the property value based on a property name (generic setter).
     * @param name The name of the property
     * @param value The value of the property
     * @return The updated <code>Activity</code>
     */
    public Activity setProperty(String name, String value) {
		return null;
	}

    /**
     * Gets the path
     *
     * @return The path
     */
    public String getPath() {
		return null;
	}

    /**
     * Gets the resource type
     *
     * @return The resource type
     */
    public String getResourceType() {
		return null;
	}

    /**
     * Gets the <code>JSONObject</code> representing the activity.
     *
     * @return The JSON object
     */
    public JSONObject toJSON() throws JSONException {
		return null;
	}
}