/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import com.day.cq.analytics.sitecatalyst.SitecatalystAccount;
import com.day.cq.wcm.api.Page;

/**
 * The {@link AnalyticsConfiguration} interface provides access to entries of a
 * analytics configuration node.
 * 
 * @deprecated This interface will be removed in future versions and has no
 *             default implementation anymore. Use
 *             {@link com.day.cq.wcm.webservicesupport.Configuration} instead.
 * @see {@link com.day.cq.wcm.webservicesupport.Configuration}
 */
@Deprecated
public interface AnalyticsConfiguration {

    /**
     * Returns the @ Resource} of the analytics configuration.
     * 
     * @return The unterlying resource
     */
    Resource getResource() {
		return null;
	}

    /**
     * Returns the path of the analytics configuration @ Resource} .
     * 
     * @return This resource's path
     */
    String getPath() {
		return null;
	}

    /**
     * Return the path of the @ Page} where the analyics configuration resides.
     * 
     * @return The corresponding page's path
     */
    String getPagePath() {
		return null;
	}

    /**
     * Formats the resource path of a {@link Page}. A trailing slash will be
     * removed if present, all other slashes will be replaced by colons.
     * <p>
     * <code>/content/geometrixx/en/support</code> will be formatted to
     * <code>content:geometrixx:en:support</code>
     * </p>
     * 
     * @param page Page to format resource path
     * @return Formatted path
     * @deprecated
     * @see com.day.cq.analytics.sitecatalyst.SitecatalystUtil#getFormattedPageName(com.day.cq.analytics.sitecatalyst.Page)
     */
    String getFormattedPagePath(Page page) {
		return null;
	}

    /**
     * Gets a named property of the {@link Resource}'s {@link ValueMap}.
     * 
     * @param name
     * @return
     */
    Object get(String name) {
		return null;
	}

    /**
     * Gets a named property of the {@link Resource}'s {@link ValueMap} and
     * coverts it to the given type.
     * 
     * @param name
     * @param type
     * @return
     */
    <T> T get(String name, Class<T> type) {
		return null;
	}

    /**
     * Gets a named property of the {@link Resource}'s {@link ValueMap} and
     * coverts it to the given type.
     * 
     * @param <T>
     * @param name
     * @param defaultValue
     * @return
     */
    <T> T get(String name, T defaultValue) {
		return null;
	}

    /**
     * Gets the {@link ValueMap} of the {@link Resource}.
     * 
     * @return The resource's ValueMap
     */
    ValueMap getValueMap() {
		return null;
	}

    /**
     * Gets corresponding SiteCatalyst account.
     * 
     * @param <T> Account type
     * @param type Class of type {@link SitecatalystAccount}
     * @return
     */
    SitecatalystAccount getSitecatalystAccount() {
		return null;
	}

    /**
     * Checks if the service with <code>servicename</code> is configured.
     * 
     * @param servicename
     * @return
     */
    Boolean hasService(String servicename) {
		return null;
	}

}
