/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics.sitecatalyst;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import javax.jcr.Item;
import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.ValueFormatException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.crx.statistics.Entry;
import com.day.crx.statistics.PathBuilder;

public class ImpressionsEntry extends Entry {
    /** default log */
    private final Logger log = LoggerFactory.getLogger(getClass());

    /** Name of the property that contains the view count */
    public static final String VIEWS = "views";

    /** Name of the property that contains the rolling week count */
    public static final String ROLLING_WEEK_COUNT = "rollingWeekViews";

    /** Name of the property that contains the rolling month count */
    public static final String ROLLING_MONTH_COUNT = "rollingMonthViews";

    /** The page */
    private final String pagePath;

    private final long count;
    
    public ImpressionsEntry(String pathPrefix, String pagePath, String date, long count) {
        super(pathPrefix);
        this.pagePath = pagePath;
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {
            this.setTimestamp(format.parse(date).getTime());
        } catch (ParseException e) {
            log.error("error while parsing date for impressionsentry", e);
        }
        this.count = count;
    }
    
    @Override
    protected PathBuilder getPathBuilder() {
		return null;
	}

    @Override
    public void write(Node node) throws RepositoryException {
	}

    /**
     * Calculates the cumulative view count on the <code>node</code>.
     *
     * @param node
     *            the node where to update the cumulative view count
     * @param numDays
     *            the number of days back in time that are cumulated
     * @param propertyName
     *            the name of the count property
     * @throws RepositoryException
     *             if an error occurs while reading or updating.
     */
    private long getCumulativeCount(Node node, int numDays, String propName)
            throws RepositoryException, ValueFormatException {
				return 0L;
			}
}
