/*******************************************************************************
 * ADOBE CONFIDENTIAL
 *  __________________
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 *  NOTICE:  All information contained herein is, and remains
 *  the property of Adobe Systems Incorporated and its suppliers,
 *  if any.  The intellectual and technical concepts contained
 *  herein are proprietary to Adobe Systems Incorporated and its
 *  suppliers and are protected by trade secret or copyright law.
 *  Dissemination of this information or reproduction of this material
 *  is strictly forbidden unless prior written permission is obtained
 *  from Adobe Systems Incorporated.
 ******************************************************************************/

package com.day.cq.analytics.testandtarget;

/**
 * A request object used to retrieve a list of offers from Adobe Target.
 * This  class is currently a no-op, but it will be upgraded to support filtering when the Target API
 * offers will support this
 */
public class ListOffersRequest {

    private boolean includeContent;

    /**
     * Constructs a {@link ListOffersRequest} using the default values (includeContent is false)
     */
    public ListOffersRequest() {
        this.includeContent = false;
    }

    /**
     * Sets the includeContent flag on this request
     *
     * @param include if set to true, the response object(s) will also include the content of the offers, otherwise they won't
     * @return the current {@link ListOffersRequest} object
     */
    public ListOffersRequest includeContent(boolean include) {
		return null;
	}

    /**
     * Returns true if this offers request has been instructed to also retrieve the offer's content
     * @return true if the includeContent flag is set, false otherwise.
     */
    public boolean includeContent() {
		return false;
	}
}
