/*******************************************************************************
 * ADOBE CONFIDENTIAL
 *  __________________
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 *  NOTICE:  All information contained herein is, and remains
 *  the property of Adobe Systems Incorporated and its suppliers,
 *  if any.  The intellectual and technical concepts contained
 *  herein are proprietary to Adobe Systems Incorporated and its
 *  suppliers and are protected by trade secret or copyright law.
 *  Dissemination of this information or reproduction of this material
 *  is strictly forbidden unless prior written permission is obtained
 *  from Adobe Systems Incorporated.
 ******************************************************************************/

package com.day.cq.analytics.testandtarget;

import aQute.bnd.annotation.ProviderType;
import com.day.cq.wcm.webservicesupport.Configuration;

/**
 * The <tt>TargetMediator</tt> creates and keeps sync of reusable Adobe Target objects such as segments and offers
 */
@ProviderType
public interface TargetMediator extends TestandtargetCampaignMediator{

    /**
     * The JCR property that holds the Adobe Target id on the managed objects
     * @deprecated Use {@link TargetMediator#PN_PUBLISH_EXTERNAL_ID} or {@link TargetMediator#PN_AUTHOR_EXTERNAL_ID}
     * instead
     */
    public static final String PN_EXTERNAL_ID = "externalId";


    /**
     * The JCR property that holds the Adobe Target id on the managed objects on the author instance.
     */
    public static final String PN_AUTHOR_EXTERNAL_ID = "authorExternalId";

    /**
     * The JCR property that holds the Adobe Target id on the managed objects on the author instance.
     */
    public static final String PN_PUBLISH_EXTERNAL_ID = "publishExternalId";

    /**
     * Synchronizes an offer with Adobe Target. After a successful synchronization this method returns the object id from Target
     * @param offerPath the repository path of the offer.
     * @param configuration the cloud services configuration containing the Adobe Target account details
     *
     * @return the object id from Target
     */
    public long syncOffer(Configuration configuration, String offerPath) throws TestandtargetException {
		return 0L;
	}


    /**
     * Synchronizes a segment with Adobe Target
     * @param segmentPath
     * @param configuration the cloud services configuration containing the Adobe Target account details
     *
     * @return the object id from Target.
     */
    public long syncSegment(Configuration configuration, String segmentPath) throws TestandtargetException {
		return 0L;
	}


}
