/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.auth.pin;

import org.apache.sling.api.resource.ResourceResolver;

/**
 * The <code>PinManagerFactory</code> defines the service interface which
 * provides access to {@link PinManager}s. The single
 * {@link #getPinManager(ResourceResolver)} method returns a {@link PinManager}
 * providing access on behalf of the user represented by the
 * <code>ResourceResolver</code>.
 * <p>
 * This interface is not intended to be implemented by applications. Rather it
 * is the interface under which the PIN manager factory service is registered
 * for use by applications wishing to manage {@link Pin}s.
 *
 * @deprecated CQ 5.6 For security reaons the PIN authentication has been
 * deprecated. Please use token based authentication instead.
 */
public interface PinManagerFactory {

    /**
     * Returns a {@link PinManager} instance for the user represented by the
     * given resource resolver.
     *
     * @param resourceResolver The <code>ResourceResolver</code> representing
     *            the user trying to manage {@link Pin}s
     * @return The {@link PinManager} for the user.
     * @throws NullPointerException if <code>resourceResolver</code> is
     *             <code>null</code>.
     */
    PinManager getPinManager(ResourceResolver resourceResolver) {
		return null;
	}

}
