/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons;

import org.apache.sling.api.resource.ValueMap;

/**
 * Encapsulates information of a product or project.
 * 
 * @deprecated CQ 5.6 - Use the granite license and product info services instead.
 */
@Deprecated
public interface ProductInfo {

    /**
     * Name of the "productInfo" node that holds the information. 
     */
    final String NN_PRODUCT_INFO = "productinfo";

    /**
     * name of the "product name" property.
     */
    final String PN_NAME = "name";

    /**
     * name of the "product short name" property.
     */
    final String PN_SHORT_NAME = "shortName";

    /**
     * name of the "product version" property.
     */
    final String PN_VERSION = "version";

    /**
     * name of the "product short version" property.
     */
    final String PN_SHORT_VERSION = "shortVersion";

    /**
     * name of the "product year" property.
     */
    final String PN_YEAR = "year";

    /**
     * name of the "product url" property.
     */
    final String PN_URL = "url";

    /**
     * name of the "vendor" property.
     */
    final String PN_VENDOR = "vendor";

    /**
     * name of the "vendor url" property.
     */
    final String PN_VENDOR_URL = "vendorUrl";

    /**
     * Returns the (full) product name, e.g. "Day Communiqu&eacute;"
     * @return the product name.
     */
    String getName() {
		return null;
	}

    /**
     * Returns the short product name, e.g. "CQ"
     * @return the short product name
     */
    String getShortName() {
		return null;
	}

    /**
     * Returns the product version. e.g. "5.3.0.20091225"
     * @return the product version.
     */
    Version getVersion() {
		return null;
	}

    /**
     * Returns the short, textual version. e.g. "5.3"
     * @return the short product version.
     */
    String getShortVersion() {
		return null;
	}

    /**
     * Returns the product year. e.g. "2009"
     * @return the product version.
     */
    String getYear() {
		return null;
	}

    /**
     * Returns the vendor. e.g. "Day Management AG"
     * @return the vendor.
     */
    String getVendor() {
		return null;
	}

    /**
     * Returns the vendor url. e.g. "http://www.day.com"
     * @return the vendor url.
     */
    String getVendorUrl() {
		return null;
	}

    /**
     * Returns the product url. e.g. "http://www.day.com/cq5"
     * @return the product url.
     */
    String getUrl() {
		return null;
	}

    /**
     * Returns all properties of this info.
     * @return all properties.
     */
    ValueMap getProperties() {
		return null;
	}

}