/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons;

import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.io.JSONWriter;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;

/**
 * A <code>ResourceStatusProvider</code> is used to provide status information
 * for a resource, usually a page or an aggregate root node.
 *
 * @deprecated This is not used anymore and replaced by com.day.cq.wcm.api.PageInfoProvider
 */
public interface ResourceStatusProvider {

    /**
     * Writes the status to the given json item writer.
     *
     * @param request the servlet request
     * @param writer the writer
     * @param resource the resource to retrieve the status for
     * @throws JSONException if an error occurrs.
     */
    void writeStatus(SlingHttpServletRequest request, JSONWriter writer,
                     Resource resource)
            throws JSONException {
	}

}