/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons.feed;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import javax.jcr.RepositoryException;
import java.io.IOException;
import java.util.Calendar;
import java.text.SimpleDateFormat;

/**
 * The <code>RssFeed</code> class prints a resource as an RSS feed.
 */
public class RssFeed extends AbstractFeed {

    /**
     * Creates a new <code>RssFeed</code> instance using the specified
     * servlet request and response.
     * @param req The servlet request
     * @param resp The servlet response
     * @throws RepositoryException if no node can be found
     */
    public RssFeed(SlingHttpServletRequest req, SlingHttpServletResponse resp)
            throws RepositoryException {
        super(null, req, resp);
    }

    /**
     * Creates a new <code>RssFeed</code> instance using the specified
     * resource, servlet request and response.
     * @param res The resource
     * @param req The servlet request
     * @param resp The servlet response
     * @throws RepositoryException if no node can be found
     */
    public RssFeed(Resource res, SlingHttpServletRequest req, SlingHttpServletResponse resp)
            throws RepositoryException {
        super(res, req, resp);
    }

    /**
     * {@inheritDoc}
     */
    public void printHeader() throws IOException {
	}

    /**
     * {@inheritDoc}
     */
    public void printEntry() throws IOException {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getContentType() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    String getFeedEntryPath(Resource res) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    protected String getFeedLink() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    protected String formatDate(Calendar calendar) {
		return null;
	}

}