/*
 * Copyright 1997-2012 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons.servlets;

import com.day.cq.replication.ReplicationStatus;
import org.apache.felix.scr.annotations.Component;
import org.apache.sling.api.SlingHttpServletRequest;
import java.text.Collator;
import java.util.*;

/**
 * The <code>AbstractReplicableListServlet</code> provides base functionality
 * such as sorting and paging for servlets that feed Ext grids (like in the
 * SiteAdmin) with JSON. In contrast to <code>AbstractListServlet</code>
 * sorting by <code>ReplicationStatus</code> is supported.
 * Normally, the list of children of the addressed resource are returned.
 * Alternatively, the paging index of an item can be requested.
 */
@Component(metatype = false, componentAbstract = true)
public class AbstractReplicableListServlet extends AbstractListServlet {

    /**
     * Value of the sort paramter to indicate to sort the results by
     * replication date.
     */
    public static final String SORT_REPLICATION = "replication";

    /**
     * {@inheritDoc}
     */
    protected List<AbstractListServlet.ListItem> applySorting(SlingHttpServletRequest request,
                                          List<AbstractListServlet.ListItem> items) {
											return null;
										}

    /**
     * {@inheritDoc}
     */
    @SuppressWarnings({"UnusedDeclaration"})
    public interface ListItem extends AbstractListServlet.ListItem {

        /**
         * Get the replication status of the item
         * @return ReplicationStatus replication status
         */
        public ReplicationStatus getReplicationStatus() {
			return null;
		}
    }

    /**
     * {@inheritDoc}
     */
    public class ListItemComparator implements Comparator<AbstractListServlet.ListItem> {

        private String compareField;

        /**
         * {@inheritDoc}
         */
        public ListItemComparator(String compareField) {
            this.compareField = compareField;
        }

        /**
         * {@inheritDoc}
         */
        public int compare(AbstractListServlet.ListItem li1, AbstractListServlet.ListItem li2) {
			return 0;
		}

    }

}
