/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons.servlets;

import com.day.cq.commons.jcr.JcrConstants;
import org.apache.felix.scr.annotations.sling.SlingServlet;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.servlets.OptingServlet;
import org.apache.sling.api.servlets.SlingSafeMethodsServlet;
import org.apache.sling.jcr.resource.JcrResourceConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import java.io.IOException;

/**
 * Simple proxy servlet that include the request to a proxied resource.
 * Dispatches ".html" requests to a "nt:file" that have a "sling:resourceType"
 * property set on their "jcr:content" node, to the "jcr:content" resource.
 */
@SlingServlet(resourceTypes = "nt:file", extensions = "html")
public class ProxyServlet extends SlingSafeMethodsServlet implements OptingServlet {

    private static final long serialVersionUID = -2132087866168663893L;
    /**
     * default log
     */
    private final Logger log = LoggerFactory.getLogger(ProxyServlet.class);

    @Override
    protected void service(SlingHttpServletRequest request,
                           SlingHttpServletResponse response)
            throws ServletException, IOException {
			}

    /**
     * {@inheritDoc}
     * <p/>
     * Does not proxy for request to a nt:file that have no sling:resource type
     * set in the jcr:content node.
     */
    public boolean accepts(SlingHttpServletRequest request) {
		return false;
	}
}