/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.dam.core.process;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.PathNotFoundException;
import javax.jcr.PropertyIterator;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.Value;

import org.apache.jackrabbit.JcrConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.dam.api.Asset;
import com.day.cq.dam.api.DamConstants;
import com.day.cq.dam.commons.util.DamUtil;
import com.day.cq.workflow.metadata.MetaDataMap;

/**
 * The <code>ProcessingProfileApplier</code> is used in multiple workflow steps. At the time of
 * writing this comment it is used in Metadata Processor step and Apply Processing Profile step.
 *
 */
public class ProcessingProfileApplier {

    /**
     * Logger instance for this class.
     */
    private static final Logger log = LoggerFactory.getLogger(ProcessingProfileApplier.class);

    private static final String JCR_CONTENT_METADATA = JcrConstants.JCR_CONTENT + "/" + DamConstants.METADATA_FOLDER;

    /**
     * Applies processing profile on the given asset.
     * @param session JCR Session.
     * @param asset Asset on which processing profile is to be applied.
     * @throws RepositoryException if some repository error occurs during application.
     */
    public void applyProcessingProfile(Session session, final Asset asset) throws RepositoryException {
	}
    
	private Node createAssetMetadataNode(Node assetNode) throws RepositoryException {
		return null;
	}

    private void applyMetadataProfile(final Session session, final Asset asset, final String path) throws RepositoryException {
	}
    
    private void copyMetadataProfileValues(Node metadataProfileNode, Node assetNode) throws PathNotFoundException, RepositoryException {
	}
    
    private void copyProperties(Node metadataProfileNode, Node assetMetadataNode) throws RepositoryException {
	}
    
    // TODO Remove duplicate code in metadatainstance.jsp
    private List<Node> getFormItems(Node metadataProfileNode) throws PathNotFoundException, RepositoryException {
		return null;
	}
}
