/*
 * Copyright 1997-2011 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.handler.standard.msoffice.wmf;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.awt.Dimension;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.Color;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.FontMetrics;
import java.awt.image.ColorModel;
import java.awt.image.ImageConsumer;
import java.awt.image.ImageProducer;
import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.awt.image.MemoryImageSource;
import java.awt.image.BufferedImage;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.EOFException;
import java.util.Stack;
import java.util.Vector;
import java.util.Enumeration;

/**
 * WMF file interpreter.
 * Taken from old DAM media handler project com.day.cq.dam.media.handler.office.wmf
 */
public class WmfDecoder implements ImageProducer {

    private static final Logger log = LoggerFactory.getLogger(WmfDecoder.class);

    boolean drawCross_if_error = true;
    private int minsize = 7;
    private int top, left, siz, obj, max;
    private int res;
    private int inch;
    private WmfDecObj gdiObj[];
    private Stack DCstack;
    private int rgbPixels[] = null;
    private short params[];
    private int width = -1, height = -1;
    private InputStream in;
    private ColorModel cmodel = ColorModel.getRGBdefault();
    private boolean err = false;
    private boolean producing = false;
    private Vector consumers = new Vector();
    private byte[] data;
    private int factor = 1;

    // constructor
    public WmfDecoder(byte[] data) {
        this.data = data;
    }

    private InputStream getStream() {
		return null;
	}

    // -------- methods that implement ImageProducer -----------------------
    public void addConsumer(ImageConsumer ic) {
	}

    public void startProduction(ImageConsumer ic) {
	}

    public boolean isConsumer(ImageConsumer ic) {
		return false;
	}

    public void removeConsumer(ImageConsumer ic) {
	}

    public void requestTopDownLeftRightResend(ImageConsumer ic) {
	}

    // ---- method connects the Wmf interpreter with ImageProducer methods
    private void sendImage() {
	}

    private static void printObserverStatus(String text, int status) {
	}

    public Dimension getDimension() throws IOException {
		return null;
	}

    // ---- main method for reading Wmf into a pixel array -------------------
    private void readWmf() throws IOException, InterruptedException {
	}

    private boolean chkHeader(InputStream in, Dimension d) throws IOException {
		return false;
	}

    private boolean readRecord(InputStream in) {
		return false;
	}

    private void drawOpaqePattern(Graphics g, Image im, int x1, int y1, int x2, int y2,
                                  ImageObserver fr) {
								}

    private int getHiByteVal(int hhh) {
		return 0;
	}

    private int getLoByteVal(int hhh) {
		return 0;
	}

    private int transform(int param, int minsize) {
		return 0;
	}

    private void showparams(short[] params, int recSize, int Func) {
	}

    private int add_handle(WmfDecObj x) {
		return 0;
	}

    private int readInt32(InputStream in) throws IOException {
		return 0;
	}

    private short readInt16(InputStream in) throws IOException {
		return 0;
	}

    private int arcus(int ank, int geg) {
		return 0;
	}

    // ----------- called by META_STRETCHDIB ----------- (1, 4, 8 bpp only, no
    // RLE) --------
    private Image DIBBitmapImage(int off, short params[])// ,Component comp)
    {
		return null;
	}

    // ----------- called by META_STRETCHBLT ----------- (here monochrome only)
    // --------
    private Image OldBitmapImage(int off, short params[])// ,Component comp)
    {
		return null;
	}

    private final static int META_SETBKCOLOR = 0x0201; //
    private final static int META_SETBKMODE = 0x0102; //
    private final static int META_SETMAPMODE = 0x0103; //
    private final static int META_SETROP2 = 0x0104; //
    private final static int META_SETRELABS = 0x0105;
    private final static int META_SETPOLYFILLMODE = 0x0106; //
    private final static int META_SETSTRETCHBLTMODE = 0x0107;
    private final static int META_SETTEXTCHAREXTRA = 0x0108;
    private final static int META_SETTEXTCOLOR = 0x0209; //
    private final static int META_SETTEXTJUSTIFICATION = 0x020A; //
    private final static int META_SETWINDOWORG = 0x020B; //
    private final static int META_SETWINDOWEXT = 0x020C; //
    private final static int META_SETVIEWPORTORG = 0x020D;
    private final static int META_SETVIEWPORTEXT = 0x020E;
    private final static int META_OFFSETWINDOWORG = 0x020F;
    private final static int META_SCALEWINDOWEXT = 0x0410;
    private final static int META_OFFSETVIEWPORTORG = 0x0211;
    private final static int META_SCALEVIEWPORTEXT = 0x0412;
    private final static int META_LINETO = 0x0213; //
    private final static int META_MOVETO = 0x0214; //
    private final static int META_EXCLUDECLIPRECT = 0x0415;
    private final static int META_INTERSECTCLIPRECT = 0x0416;
    private final static int META_ARC = 0x0817; //
    private final static int META_ELLIPSE = 0x0418; //
    private final static int META_FLOODFILL = 0x0419;
    private final static int META_PIE = 0x081A; //
    private final static int META_RECTANGLE = 0x041B; //
    private final static int META_ROUNDRECT = 0x061C; //
    private final static int META_PATBLT = 0x061D; //
    private final static int META_SAVEDC = 0x001E;
    private final static int META_SETPIXEL = 0x041F; //
    private final static int META_OFFSETCLIPRGN = 0x0220;
    private final static int META_TEXTOUT = 0x0521; //
    private final static int META_BITBLT = 0x0922;
    private final static int META_STRETCHBLT = 0x0B23; //
    private final static int META_POLYGON = 0x0324; //
    private final static int META_POLYLINE = 0x0325; //
    private final static int META_ESCAPE = 0x0626; //
    private final static int META_RESTOREDC = 0x0127; //
    private final static int META_FILLREGION = 0x0228;
    private final static int META_FRAMEREGION = 0x0429;
    private final static int META_INVERTREGION = 0x012A;
    private final static int META_PAINTREGION = 0x012B;
    private final static int META_SELECTCLIPREGION = 0x012C; //
    private final static int META_SELECTOBJECT = 0x012D; //
    private final static int META_SETTEXTALIGN = 0x012E; //
    private final static int META_DRAWTEXT = 0x062F;
    private final static int META_CHORD = 0x0830; //
    private final static int META_SETMAPPERFLAGS = 0x0231;
    private final static int META_EXTTEXTOUT = 0x0A32; //
    private final static int META_SETDIBTODEV = 0x0D33;
    private final static int META_SELECTPALETTE = 0x0234; //
    private final static int META_REALIZEPALETTE = 0x0035; //
    private final static int META_ANIMATEPALETTE = 0x0436;
    private final static int META_SETPALENTRIES = 0x0037;
    private final static int META_POLYPOLYGON = 0x0538; //
    private final static int META_RESIZEPALETTE = 0x0139;
    private final static int META_DIBBITBLT = 0x0940; //
    private final static int META_DIBSTRETCHBLT = 0x0B41; //
    private final static int META_DIBCREATEPATTERNBRUSH = 0x0142; //
    private final static int META_STRETCHDIB = 0x0F43; //
    private final static int META_EXTFLOODFILL = 0x0548;
    private final static int META_RESETDC = 0x014C;
    private final static int META_STARTDOC = 0x014D;
    private final static int META_STARTPAGE = 0x004F;
    private final static int META_ENDPAGE = 0x0050;
    private final static int META_ABORTDOC = 0x0052;
    private final static int META_ENDDOC = 0x005E;
    private final static int META_DELETEOBJECT = 0x01F0; //
    private final static int META_CREATEPALETTE = 0x00F7; //
    private final static int META_CREATEBRUSH = 0x00F8;
    private final static int META_CREATEPATTERNBRUSH = 0x01F9;
    private final static int META_CREATEPENINDIRECT = 0x02FA; //
    private final static int META_CREATEFONTINDIRECT = 0x02FB; //
    private final static int META_CREATEBRUSHINDIRECT = 0x02FC; //
    private final static int META_CREATEBITMAPINDIRECT = 0x02FD;
    private final static int META_CREATEBITMAP = 0x06FE;
    private final static int META_CREATEREGION = 0x06FF; //

    private final static int MFCOMMENT = 15;
    private final static int SRCCOPY = 0xCC0020;
    private final static int PATCOPY = 0xF00021;
    private final static int PATINVERT = 0x5A0049;
    private final static int DSTINVERT = 0x550009;
    private final static int BLACKNESS = 0x000042;
    private final static int WHITENESS = 0xFF0062;
    private final static int BI_RLE8 = 1;
    private final static int BI_RLE4 = 2;

    private final static int TA_BASELINE = 24; // TextAlign options
    private final static int TA_BOTTOM = 8;
    private final static int TA_CENTER = 6;
    private final static int TA_UPDATECP = 1; // FIXME: update current postion
    final static int TA_TOP = 0;
    final static int OPAQUE = 2;
    final static int TRANSPARENT = 1;
    final static int ETO_GRAYED = 1;
    final static int ETO_OPAQUE = 2;
    final static int ETO_CLIPPED = 4;
    final static int PS_SOLID = 0;
    final static int PS_DASH = 1;
    final static int PS_DOT = 2;
    final static int PS_DASHDOT = 3;
    final static int PS_DASHDOTDOT = 4;
    final static int PS_NULL = 5;
    final static int PS_INSIDEFRAME = 6;
}

// this an all_in_one class of GDI-objects -------------------------------------

class WmfDecObj {
    /**
     * the default logger
     */
    private static final Logger log = LoggerFactory.getLogger(WmfDecObj.class);

    final static int M_PEN = 1;// the Windows GDI uses some other magic
    // words...
    final static int M_BRUSH = 2;
    final static int M_FONT = 3;
    final static int M_BITMAP = 4;
    final static int M_CLIP = 5;
    final static int M_PALETTE = 6;

    private Color c;
    private Font f;
    private boolean f_underl;
    private int f_orient;
    private Rectangle r;
    private int magic;
    private Image ibrush;
    private int hatch;
    private int p_style;

    WmfDecObj(Color cc, int mm) {
        this.c = cc;
        this.magic = mm;
    }

    WmfDecObj(int penattr, Color cc) {
        this.c = cc;
        this.magic = M_PEN;
        this.p_style = penattr;
    }

    WmfDecObj(Font ff, int underlined, int orientation) {
        this.f = ff;
        this.f_underl = underlined == 0 ? false : true;
        this.f_orient = orientation;
        this.magic = M_FONT;
    }

    WmfDecObj(Image ii) {
        this.ibrush = ii;
        this.c = null;
        this.magic = M_BRUSH;
    }

    WmfDecObj(int hatchstyle, Color cc, Color back)// ,Component fr)
    {
        this.c = cc; // TRANSPARENT mode not suppd
        this.hatch = hatchstyle;
        this.ibrush = this.createOpaqueImage(hatchstyle, cc, back);// ,fr);
        this.magic = M_BRUSH;
    }

    WmfDecObj(int left, int top, int right, int bottom) {
        this.r = new Rectangle(left, top, right - left, bottom - top);
        this.magic = M_CLIP;
    }

    Color getColor() {
		return null;
	}

    Image getImage() {
		return null;
	}

    Font getFont() {
		return null;
	}

    boolean isUnderlined() {
		return false;
	}

    int getFontOrientation() {
		return 0;
	}

    int getPenStyle() {
		return 0;
	}

    Rectangle getRect() {
		return null;
	}

    // int getHatch()
    // {
    // return hatch;
    // }

    int getMagic() {
		return 0;
	}

    Image createOpaqueImage(int hatchstyle, Color cc, Color back)// ,Component
            // fr)
    {
		return null;
	}

}

// Consider: this is NOT really what Windows-GDI does!

class WmfDecDC implements Cloneable {
    WmfDecDC(int extX, int extY, int orgX, int orgY) {
        // init (some metafiles don't call META_SETWINDOWEXT/META_SETWINDOWORG
        // !)
        this.winextX = (short) (this.truewidth = extX);
        this.winextY = (short) (this.trueheight = extY);
        this.winorgX = (short) orgX;
        this.winorgY = (short) orgY;
        this.aktclip = new WmfDecObj(this.winorgX, this.winorgY, this.winextX, this.winextY);
        this.aktpen = new WmfDecObj(WmfDecoder.PS_SOLID, Color.black);
        this.aktbrush = new WmfDecObj(Color.white, WmfDecObj.M_BRUSH);
        this.aktpal = new WmfDecObj(Color.white, WmfDecObj.M_PALETTE);
        this.aktbmp = new WmfDecObj(Color.white, WmfDecObj.M_BITMAP);
        this.aktfont = new WmfDecObj(new Font("Courier", Font.PLAIN, 12), 0, 0);
    }

    // this is our "device context" (DC), init'd with GDI defaults
    // it has 6 selectable objects
    public WmfDecObj aktpen, aktbrush, aktpal, aktbmp, aktclip, aktfont;

    public Color akttextc = Color.black;
    public Color aktbackgnd = Color.white; // for usage in NULL-pens and
    // -brushs
    public int aktYpos = 0; // current graphic cursor (MoveTo,LineTo)
    public int aktXpos = 0;
    public short winextX = (short) 1; // for SetWindowExt()
    public short winextY = (short) 1;
    public short winorgX = (short) 0; // for SetWindowOrg()
    public short winorgY = (short) 0;
    public int slevel = 0; // SaveDC-level
    public int akttextalign = WmfDecoder.TA_TOP;
    public int aktbkmode = WmfDecoder.OPAQUE;
    public Graphics gr;

    // --------- still missing: ROP, ViewPort,MapMode,PolyfillMode etc.

    private int trueheight, truewidth; // not part of GDI device context

    int ytransfer(short coo) {
		return 0;
	}

    int xtransfer(short coo) {
		return 0;
	}

    public Object clone() // not yet ready
    {
		return null;
	}
}
