/*
 * Copyright 1997-2011 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.handler.standard.ooxml;

import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.commons.io.IOUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.commons.mime.MimeTypeService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.traversal.DocumentTraversal;
import org.w3c.dom.traversal.NodeFilter;
import org.w3c.dom.traversal.NodeIterator;

import com.day.cq.dam.api.Asset;
import com.day.cq.dam.api.Rendition;
import com.day.cq.dam.api.metadata.ExtractedMetadata;
import com.day.cq.dam.commons.handler.AbstractAssetHandler;
import com.day.image.Layer;
import com.day.cq.dam.commons.xml.DocumentBuilderFactoryProvider;

/**
 * Open Office metadata handler service
 * */
@Component(inherit = true, metatype = false)
@Service
public class OpenOfficeHandler extends AbstractAssetHandler {

    private static final Logger log = LoggerFactory.getLogger(OpenOfficeHandler.class);

    public static final String MIMETYPE_DOCX
            = "application/vnd.openxmlformats-officedocument.wordprocessingml.document";
    public static final String MIMETYPE_XLSX
            = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
    public static final String[] MIMETYPES_SUPPORTED = new String[] {MIMETYPE_DOCX, MIMETYPE_XLSX};

    // zip entries containing meta data
    private static final String ENTRY_CORE = "docProps/core.xml";
    private static final String ENTRY_APP = "docProps/app.xml";
    //todo this needs to be tested with documents created on windows. (PNG vs JPEG)
    private static final String ENTRY_THUMBNAIL = "docProps/thumbnail.jpeg";
    private static final String ENTRY_THUMBNAIL_EMF = "docProps/thumbnail.emf";

    @Reference(policy = ReferencePolicy.STATIC)
    protected MimeTypeService mimeTypeService;
    
    private static final String META_KEY_THUMBNAIL = "thumbnail";

    public ExtractedMetadata extractMetadata(final Asset asset) {
		return null;
	}

    public BufferedImage getImage(final Rendition rendition) throws IOException {
		return null;
	}

    public BufferedImage getImage(final Rendition rendition, final Dimension dim) throws IOException {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public String[] getMimeTypes() {
		return null;
	}

    /* all private methods */
    private void readEntries(final ZipInputStream zis, final ExtractedMetadata metadata, final Asset asset) throws Exception {
	}

}
