/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.scene7;

import java.util.Map;

import com.day.cq.dam.scene7.impl.PublishingJob;

/**
 * The <code>Scene7Publisher</code> is used to add and remove <code>PublishingJob</code> instances to the Scheduler. A job is executed in a
 * periodic manner within a default interval of <code>JOB_PERIOD</code>, which is 60 seconds by default.
 * 
 * @deprecated Please change your code so that it uses {@link com.day.cq.dam.scene7.api.Scene7Publisher}.
 */
public interface Scene7Publisher {

    /**
     * Adds a {@link PublishingJob} to the {@link Scheduler}.
     * 
     * @param email
     *            E-Mail address of issuer.
     * @param password
     *            Password
     * @param companyHandle
     *            Company handle
     * @param assetType
     *            type of Scene7 asset
     * @param path
     *            Path to the asset
     * @param datacenterUrl
     *            Scene7 data centre URL
     * @param publishStatusQueryMap
     *            Parameter map for to query for assets effected by the Publish
     * @deprecated Please use the
     *             {@code com.day.cq.dam.scene7.api.Scene7Publisher.addJob(String email, String password, String companyHandle, String path, String datacenterUrl, Map<String,String> publishStatusQueryMap)}
     *             method instead.
     */
    void addJob(String email, String password, String companyHandle, String path, String datacenterUrl,
            Map<String, String> publishStatusQueryMap) {
	}

    /**
     * Removes a {@link com.day.cq.dam.scene7.impl.PublishingJob} from the {@link org.apache.sling.commons.scheduler.Scheduler}.
     * 
     * @param name
     *            Name of the {@link com.day.cq.dam.scene7.impl.PublishingJob}.
     */
    void removeJob(String name) {
	}

}