package com.day.cq.dam.video;

import static com.day.cq.commons.jcr.JcrConstants.JCR_CONTENT;
import static com.day.cq.dam.api.DamConstants.DC_EXTENT;
import static com.day.cq.dam.api.DamConstants.METADATA_FOLDER;
import static com.day.cq.dam.api.DamConstants.TIFF_IMAGELENGTH;
import static com.day.cq.dam.api.DamConstants.TIFF_IMAGEWIDTH;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.commons.mime.MimeTypeService;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.dam.api.Asset;
import com.day.cq.dam.commons.process.AbstractAssetWorkflowProcess;
import com.day.cq.dam.handler.ffmpeg.ExecutableLocator;
import com.day.cq.dam.handler.ffmpeg.FFMpegWrapper;
import com.day.cq.dam.handler.ffmpeg.FfmpegNotFoundException;
import com.day.cq.workflow.WorkflowException;
import com.day.cq.workflow.WorkflowSession;
import com.day.cq.workflow.exec.WorkItem;
import com.day.cq.workflow.metadata.MetaDataMap;

/**
 * The <code>AbstractFFMpegProcess</code> class prepares a video asset processed
 * using FFMpeg
 * 
 */
@Component(componentAbstract = true, metatype=true)
public abstract class AbstractFFMpegProcess extends AbstractAssetWorkflowProcess {

    protected final Logger log = LoggerFactory.getLogger(getClass());

    /**
     * FFmpeg working directory. If relative, relative to sling.home.
     * 
     */
    @Property(value="./logs/ffmpeg")
    public static final String PROP_WORKING_DIR = "ffmpeg.workingdir";
    
    @Reference(policy = ReferencePolicy.STATIC)
    protected MimeTypeService mimeTypeService;

    @Reference(policy = ReferencePolicy.STATIC)
    protected ExecutableLocator locator;

    private File workingDir;

    public void execute(WorkItem workItem, WorkflowSession wfSession, MetaDataMap metaData) throws WorkflowException {
	}
    
    public File getWorkingDir() {
		return null;
	}
    
    private File resolveWorkingDir(String slingHome, String path) {
		return null;
	}
    
    protected void activate(ComponentContext ctx) {
	}

    /**
     * creates a temporary directory in the given dir.
     * 
     * @param parentDir parent directory in which temporary directory is to be
     *            created
     */
    protected File createTempDir(File parentDir) {
		return null;
	}

    abstract String[] buildArguments(MetaDataMap metaData) {
		return null;
	}

    abstract void processVideo(final MetaDataMap metaData, final Asset asset, final File tmpFile, final WorkflowSession wfSession) throws IOException,
            RepositoryException {
	}

}
