package com.day.cq.dam.video;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.jcr.RepositoryException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Service;

import com.day.cq.dam.api.Asset;
import com.day.cq.dam.commons.thumbnail.ThumbnailGenerator;
import com.day.cq.dam.handler.ffmpeg.FFMpegWrapper;
import com.day.cq.workflow.WorkflowSession;
import com.day.cq.workflow.metadata.MetaDataMap;

/**
 * Workflow process that calls FFMPEG on the command line to create thumbnails of the image. You can specify the
 * dimension of the thumbnails to be created
 * <p/>
 * For example, using the following workflow step arguments:
 * <p/>
 * <pre>
 *    count:3,index:1,start:10,[140x100],[48x48]
 * </pre>
 * <p/>
 * Will create thumbnails of size 140x100 and 48x48 with a black letterbox/pillarbox
 * <p/>
 * This will only happen for assets having a video-based mime-type, others are ignored.
 *
 */
@Component(label = "Day CQ DAM FFmpeg Thumbnail Process", description = "Workflow process that creates thumbnails from video files")
@Service
@Properties({ @Property(name = "process.label", value = "Create Video Thumbnails", propertyPrivate=true) })
public class FFMpegThumbnailProcess extends AbstractFFMpegProcess{
    
    /**
     * The available arguments to this process implementation.
     */
    public enum Arguments {
        PROCESS_ARGS("PROCESS_ARGS"), START("start"), COUNT("count"), INDEX("index"), CONFIGS("CONFIGS");
        private String argumentName;

        Arguments(String argumentName) {
            this.argumentName = argumentName;
        }

        public String getArgumentName() {
            return this.argumentName;
        }

        public String getArgumentPrefix() {
            return this.argumentName + ":";
        }
    }

    protected void processVideo(final MetaDataMap metaData, final Asset asset, final File tmpFile, final WorkflowSession wfSession)
            throws IOException, RepositoryException {
			}

    public String[] buildArguments(MetaDataMap metaData) {
		return null;
	}

}
