/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.jobs.core;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

/** Time interval based on hour and minute of the day,
 *  used to define when background jobs are allowed
 *  to run.
 */
public class DailyTimeInterval {
    private final int startMinuteInDay;
    private final int endMinuteInDay;
    private final String stringRepresentation;
    private final static int MIN_PER_HOUR = 60;
    
    @SuppressWarnings("serial")
    public static class ParseException extends Exception {
        ParseException(String input, String reason) {
            super("Invalid item '" + input + "': " + reason);
        }
    }
    
    public DailyTimeInterval(int startHour, int startMinute, int endHour, int endMinute) {
        startMinuteInDay = startHour * MIN_PER_HOUR + startMinute;
        endMinuteInDay = endHour * MIN_PER_HOUR + endMinute;
        
        final StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(":");
        sb.append(startHour);
        sb.append(":");
        sb.append(startMinute);
        sb.append("-");
        sb.append(endHour);
        sb.append(":");
        sb.append(endMinute);
        stringRepresentation = sb.toString();
    }

    @Override
    public String toString() {
		return null;
	}
    
    /** True if c is within this interval */
    public boolean isInInterval(Calendar c) {
		return false;
	}
    
    /** Parse a single interval from a String */
    public static DailyTimeInterval parse(String str) throws ParseException {
		return null;
	}
    
    /** Parse a comma-separated list of intervals from a String */
    public static List<DailyTimeInterval> parseList(String str) throws ParseException {
		return null;
	}
    
    private static int parseInt(String str) throws ParseException {
		return 0;
	}
}