/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.polling.importer;

import org.apache.sling.api.SlingException;

/**
 * The <code>ImportException</code> class is the exception, which may be thrown
 * by the
 * {@link Importer#importData(String, String, org.apache.sling.api.resource.Resource)}
 * method in case of any data access, transfer or import problems.
 */
public class ImportException extends SlingException {

    public ImportException(String text) {
        super(text);
    }

    public ImportException(Throwable cause) {
        super(cause);
    }

    public ImportException(String text, Throwable cause) {
        super(text, cause);
    }

}
