/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.replication;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.sling.event.EventPropertiesMap;
import org.apache.sling.event.dea.DEAConstants;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventProperties;

/**
 * An event fired when some {@link ReplicationAction} needs to be handled
 */
public class ReplicationEvent implements Serializable {

    public static final String EVENT_TOPIC = "com/adobe/granite/replication";
    public static final String PATHS = "paths";

    private static final String PROPERTY_MODIFICATIONS = "modifications";
    private static final String TYPE = "type";
    private static final String TIME = "time";
    private static final String USER_ID = "userId";
    private static final String REVISION = "revision";

    /**
     * the replication action associated with this event
     */
    private ReplicationAction replicationAction;

    /**
     * Is this a local event?
     */
    private final boolean isLocal;


    public ReplicationEvent(ReplicationAction replicationAction) {
        this(replicationAction, true);
    }

    public ReplicationEvent(ReplicationAction replicationAction, boolean isLocal) {
        this.replicationAction = replicationAction;
        this.isLocal = isLocal;
    }

    /**
     * Returns the underlying {@link ReplicationAction} which fired this event
     *
     * @return the replication action which caused the event
     */
    public ReplicationAction getReplicationAction() {
		return null;
	}

    /**
     * Convert an OSGi event to a replication event if possible.
     *
     * @param evt The OSGi event.
     * @return The replication event
     */
    public static ReplicationEvent fromEvent(Event evt) {
		return null;
	}

    /**
     * Generate a dictionary for the OSGi event.
     *
     * @return an event property map
     * @deprecated Use {@link #getEventProperties(boolean)} instead.
     */
    @Deprecated
    protected EventPropertiesMap getEventProperties() {
		return null;
	}

    /**
     * Generate a dictionary for the OSGi event.
     *
     * @param distribute Whether this event should be distributed across the cluster.
     * @return OSGi event properties
     * @since 5.18.0
     */
    protected Map<String, Object> getEventProperties(final boolean distribute) {
		return null;
	}

    /**
     * Create a distributable event.
     *
     * @return An event.
     */
    public Event toEvent() {
		return null;
	}

    /**
     * Create a non distributable event.
     *
     * @return An event.
     */
    public Event toNonDistributableEvent() {
		return null;
	}
}
