/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.rewriter.pipeline;


/**
 * The <code>RewriterTransformerFactory</code> is an optional component
 * which can be used to enhance the rewriting pipeline.
 * All available rewriting transformers with a service ranking below
 * zero are chained before the default link rewriter. All available
 * transformers with a service ranking higher or equal to zero are
 * chained after the default link rewriter. Therefore the property
 * "service.ranking" should be used for the factory.
 *
 * The factories itself are not chained but the resulting transformers
 * are. On each pipeline call new instances are created.
 * @deprecated Use the Apache Sling Rewriter Module (org.apache.sling.rewriter.Transformer)
 */
@Deprecated
public interface RewriterTransformerFactory {

    /**
     * Create a new transformer for the pipeline.
     * @return A new transformer.
     */
    Transformer createTransformer() {
		return null;
	}
}
