/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.search.eval;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.ValueFormatException;
import javax.jcr.query.Row;

import org.apache.felix.scr.annotations.Component;
import org.apache.jackrabbit.util.Text;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.search.Predicate;

/**
 * {@linkplain JcrBoolPropertyPredicateEvaluator} is a
 * {@link JcrPropertyPredicateEvaluator} specialized for boolean properties. It
 * only accepts the values "true" and "false" and in the case of "false" it will
 * check for both the value "false" and a non-existent property at all. The
 * inherited "operation" parameter has no meaning.
 * 
 * <h3>Name:</h3>
 * boolproperty
 *
 * <h3>Properties:</h3>
 * <dl>
 * <dt>boolproperty</dt>
 * <dd>relative path to property</dd>
 * <dt>value</dt>
 * <dd>value to check property for</dd>
 * <dl>
 * 
 * @since 5.3
 */
@Component(metatype = false, factory="com.day.cq.search.eval.PredicateEvaluator/boolproperty")
public class JcrBoolPropertyPredicateEvaluator extends
        JcrPropertyPredicateEvaluator {

    private static final Logger log = LoggerFactory.getLogger(JcrBoolPropertyPredicateEvaluator.class);
    
    public static final String BOOLPROPERTY = "boolproperty";
    
    @Override
    public String getXPathExpression(Predicate p, EvaluationContext context) {
		return null;
	}
    
    @Override
    public boolean includes(Predicate p, Row row, EvaluationContext context) {
		return false;
	}
}
