/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.search.eval;

import java.util.Comparator;

import javax.jcr.query.Row;

import org.apache.felix.scr.annotations.Component;
import org.apache.jackrabbit.util.ISO9075;
import org.apache.jackrabbit.util.Text;

import com.day.cq.search.Predicate;

/**
 * <code>PathPredicateEvaluator</code> restricts the result to a node path.
 * <p/>
 * <h3>Name:</h3> path
 * <p/>
 * <h3>Properties:</h3>
 * <dl>
 * <dt>path</dt>
 * <dd>path pattern; depending on <code>exact</code>, either the entire subtree
 * will match (like appending //* in xpath, but note that this does not include
 * the base path) (exact=false, default) or only an exact path matches, which
 * can include wildcards (*); if <code>self</code> is set, the entire subtree
 * including the base node will be searched</dd>
 * <dt>exact</dt>
 * <dd>if exact is true/on, the exact path must match, but it can contain simple
 * wildcards (*), that match names, but not "/"; if it is false (default) all
 * descendents are included (optional)</dd>
 * <dt>flat</dt>
 * <dd>searches only the direct children (like appending "/*" in xpath) (only
 * used if 'exact' is not true, optional)</dd>
 * <dt>self</dt>
 * <dd>searches the subtree but includes the base node given as path
 * (no wildcards)</dd>
 * <dl>

 * @since 5.2
 */
@Component(metatype = false, factory = "com.day.cq.search.eval.PredicateEvaluator/path")
public class PathPredicateEvaluator extends AbstractPredicateEvaluator {

    public static final String PATH = "path";
    public static final String EXACT = "exact";
    public static final String FLAT = "flat";
    public static final String SELF = "self";

    /**
     * Encodes absolute paths, but keeps wildcards in case this is
     * an "exact" query containing wildcards.
     */
    public static String encodePath(Predicate p) {
		return null;
	}

    private static boolean containsWildcard(String s) {
		return false;
	}

    private static boolean match(String pattern, String s) {
		return false;
	}

    /**
     * Adapted variant from GlobPattern. Reduced to "*" wildcard only and it
     * will not match "/" (path separators).
     */
    private static boolean recurseMatchPattern(String pattern, String s, int sIdx, int pIdx) {
		return false;
	}

    @Override
    public String getXPathExpression(Predicate p, EvaluationContext context) {
		return null;
	}

    @Override
    public boolean includes(Predicate p, Row row, EvaluationContext context) {
		return false;
	}

    @Override
    public Comparator<Row> getOrderByComparator(Predicate predicate, final EvaluationContext context) {
		return null;
	}

    @Override
    public boolean canXpath(Predicate predicate, EvaluationContext context) {
		return false;
	}

    @Override
    public boolean canFilter(Predicate predicate, EvaluationContext context) {
		return false;
	}

}
