/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.search.writer;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.PropertyIterator;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.felix.scr.annotations.Component;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.io.JSONWriter;
import org.apache.sling.commons.json.jcr.JsonItemWriter;

import com.day.cq.search.Query;
import com.day.cq.search.result.Hit;

/**
 * {@linkplain FullNodeHitWriter} writes the full node using sling's standard
 * jcr node to json mapping.
 */
@Component(metatype = false, factory = "com.day.cq.search.writer.ResultHitWriter/full")
public class FullNodeHitWriter implements ResultHitWriter {

    public void write(Hit hit, JSONWriter writer, Query query) throws RepositoryException, JSONException {
	}

    /**
     * Helper class that allows to reuse an existing {@link JSONWriter} for
     * dumping a JCR node.
     */
    private static class JsonNodeDumper extends JsonItemWriter {
        
        private boolean writeACLs = false;

        public JsonNodeDumper(boolean writeACLs) {
            super(null);
            this.writeACLs = writeACLs;
        }

        @Override
        protected void dump(Node node, JSONWriter w, int currentRecursionLevel, int maxRecursionLevels)
                throws RepositoryException, JSONException {
				}

        public void dumpObject(Node node, JSONWriter w, int currentRecursionLevel, int maxRecursionLevels)
                throws RepositoryException, JSONException {
				}
        
        protected void writeACL(Node node, JSONWriter w) throws RepositoryException, JSONException {
		}
    }
}
