package com.day.cq.searchpromote.feed.api;

/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

import aQute.bnd.annotation.ConsumerType;
import com.adobe.cq.commerce.api.CommerceSession;
import com.day.cq.searchpromote.feed.FeedGeneratorException;

import java.util.List;

/**
 * Interface for a feed generator used by the Search&Promote Product Feed service.
 *
 * @deprecated This API is deprecated in favor of the Sightly generated product feed.
 */
@ConsumerType
public interface FeedGeneratorService {

    /**
     * Generates the feed and returns a {@link String} containing the data. The actual format of the data (XML, JSON,
     * CSV etc.) is
     * implementation-specific
     *
     * @param commerceSession a {@link CommerceSession} object previously obtained from a {@link com.adobe.cq
     * .commerce.api.CommerceService}. This is required for retrieving volatile information from the underlying
     *                        commerce system.
     * @param productPaths the list of JCR paths that contain products.
     * @return a {@link String} containing the feed.
     * @throws com.day.cq.searchpromote.feed.FeedGeneratorException
     */
    public String generateAsString(CommerceSession commerceSession, List<String> productPaths)
            throws FeedGeneratorException {
		return null;
	}


    /**
     * Retrieves the S&P Account number that this service is registered under. This is specified in the service's
     * configuration options
     *
     * @return The account number. The format is <code>spXXXXXXX</code>
     */
    public String getAccountNo() {
		return null;
	}

}
