package com.day.cq.searchpromote.feed.api;

/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

import aQute.bnd.annotation.ConsumerType;
import com.day.cq.searchpromote.feed.FeedGeneratorException;
import org.apache.sling.api.resource.ResourceResolver;

import java.util.List;

/**
 * Defines a products crawler used to retrieve products from the repository
 *
 * @deprecated This API is deprecated in favor of the Commerce PIM feature that does the same thing
 */
@ConsumerType
public interface ProductsCrawlerService {

    /**
     * Retrieves a list of JCR paths which contain products data.
     * @param resolver a {@link ResourceResolver} used to parse the root site and retrieve products
     * @return a {@link List} of repository paths
     * @throws com.day.cq.searchpromote.feed.FeedGeneratorException
     */

    public List<String> retrieveAllProductPaths(ResourceResolver resolver) throws FeedGeneratorException {
		return null;
	}

    /**
     * Retrieves a list of repository paths which contain products data.
     * The paths are retrieved incrementally, i.e. only the product pages added / modified since the last run are retrieved.<br/>
     * The time of the last generated feed is stored in <code>/etc/cloudservices/search-promote/<i>cloud configuration</i>/<i>scheduler configuration</i>/lastgenerated</code>
     *
     * @param resolver a {@link ResourceResolver} used to access the repository
     * @return {@link List} of repository paths
     * @throws FeedGeneratorException
     */
    public List<String> retrieveProductPathsIncremental(ResourceResolver resolver) throws FeedGeneratorException {
		return null;
	}


    /**
     * Retrieves the account number that this products crawler is registered under. This account number is specified in the service's configuration options.
     * @return  The account number. The format is <code>spXXXXXXX</code>
     */
    public String getAccountNo() {
		return null;
	}

}
