/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.core.mvt;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.PropertyIterator;
import javax.jcr.Property;

import org.apache.jackrabbit.util.Text;

import com.day.cq.wcm.api.Page;
import com.day.crx.statistics.Report;

/**
 * <code>CTRReport</code> implements a report that returns a click through rate
 * report about a page.
 */
public class CTRReport extends Report {

    /** The page */
    private final Page page;

    /**
     * Creates a new report.
     *
     * @param dataPath the location where the result statistics are stored.
     * @param page     the page that was viewed
     */
    public CTRReport(String dataPath, Page page) {
        super(dataPath);
        this.page = page;
    }

    /**
     * {@inheritDoc} Returns result rows with the following objects:
     * <ul>
     * <li>Path <code>String</code> of the image/banner.</li>
     * <li><code>Long</code> impressions: how many times the image/banner was shown</li>
     * <li><code>Long</code> clicks: how many times the image/banner was clicked</li>
     * <li><code>Double</code> the click-through-rate</li>
     * </ul>
     */
    public Iterator<Object[]> getResult(Session session)
            throws RepositoryException {
				return null;
			}
}