/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter;

import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.PageManager;
import com.day.cq.wcm.api.designer.Designer;
import com.day.cq.wcm.api.reference.Reference;
import com.day.cq.wcm.api.reference.ReferenceProvider;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Service;
import org.apache.jackrabbit.JcrConstants;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jcr.RepositoryException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

@Component
@Service
/**
 * Provides references for a canvas generated under the importer component.
 */
public class CanvasReferenceProvider implements ReferenceProvider {

    /**
     * default logger
     */
    private static final Logger logger = LoggerFactory.getLogger(CanvasReferenceProvider.class);

    private static final String IMPORTER_RESOURCE_TYPE = "wcm/designimporter/components/importer";

    private static final String CQ_CLIENT_LIBRARY_FOLDER = "cq:ClientLibraryFolder";

    private static final String NN_CANVAS = "canvas";

    private static final String PN_REIMPORT = "reimport";

    public List<Reference> findReferences(Resource resource) {
		return null;
	}

    private List<Reference> getReferences(Resource importerComponent) {
		return null;
	}

    /* Gets canvas design references */
    private List<Reference> getDesignReferences(Resource importerComponent) throws RepositoryException {
		return null;
	}

    /* Gets canvas component references */
    private List<Reference> getCanvasReferences(Resource importerComponent) throws RepositoryException {
		return null;
	}

    /* Traverses the subtree rooted at the passed root resource and adds its children to the references list
     * Note1: Excludes jcr:content because jcr:content nodes are atomically included with the parent node for replication
     * Note2: Keeps the clientlib folders pushed down the bottom. They must be published at last */
    private void addReferencesRecursive(Resource root, List<Reference> references) throws RepositoryException {
	}

    /* Checks if the passed resource is a jcr:content node */
    private boolean isContentNode(Resource r) throws RepositoryException {
		return false;
	}

    /* Determines if the resource is a ClientLibraryFolder */
    private boolean isClientLibFolder(Resource r) throws RepositoryException {
		return false;
	}

    /* Looks up importer component nodes within the tree held by the passed root.
     * Upon finding, it pushes the importer component to the passed components list*/
    private void findImporterComponent(Resource root, List<Resource> components) {
	}

}
