/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter.parser;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * Container for the HTML content of various type. Various types are classified
 * by the enumeration {@link HTMLContentType}
 */
public class ModifiableHTMLContent extends HTMLContent{

    private StringBuffer markupBuffer;

    private StringBuffer cssBuffer;

    private StringBuffer scriptBuffer;

    private List<String> referencedScripts;

    private List<String> referencedStyleSheets;

    private Map<String, String> metaData;

    public ModifiableHTMLContent(HTMLContent htmlContent) {
        this.markupBuffer = new StringBuffer((String) htmlContent.get(HTMLContentType.MARKUP));
        this.cssBuffer = new StringBuffer((String) htmlContent.get(HTMLContentType.STYLES_INLINE));
        this.scriptBuffer = new StringBuffer((String) htmlContent.get(HTMLContentType.SCRIPT_INLINE));
        this.referencedScripts = (List<String>) htmlContent.get(HTMLContentType.SCRIPT_INCLUDE);
        this.referencedStyleSheets = (List<String>) htmlContent.get(HTMLContentType.STYLESHEET_INCLUDE);
        this.metaData = (Map<String, String>) htmlContent.get(HTMLContentType.META);
    }

    /**
     * Gets the content by type
     *
     * @param htmlContentType One of the values from the enumeration {@link HTMLContentType}
     * @return The content as per type
     */
    public void set(HTMLContentType htmlContentType, Object content) {
	}

    /**
     * Gets the content by type
     *
     * @param htmlContentType One of the values from the enumeration {@link HTMLContentType}
     * @return The content as per type
     */
    @Override
    public Object get(HTMLContentType htmlContentType) {
		return null;
	}

    /**
     * Adds content to this object according to the {@link HTMLContentType}
     *
     * @param htmlContentType One of the values from the enumeration {@link HTMLContentType}
     * @param content The content as per type
     */
    @SuppressWarnings("unchecked")
    @Override
    public void add(HTMLContentType htmlContentType, Object content) {
	}



}
