/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter.parser.taghandlers;

import java.net.MalformedURLException;
import java.net.URL;

import javax.jcr.RepositoryException;

import org.xml.sax.Attributes;

/**
 * This tag handler is used to transform the src attribute within an iframe tag.
 *
 * <p>
 * Since the assets should continue to be referable, their src attribute values are prepended with the current design path. Note that design
 * path is where the assets are dumped during the import process.
 * </p>
 *
 * @see com.day.cq.wcm.designimporter.parser.taghandlers.factory.IFrameTagHandlerFactory
 */
public class IFrameTagHandler extends DefaultTagHandler {

    private String rawSrc;

    public String getRawSrc() {
		return null;
	}

    private String normalizedSrc;

    public boolean isRawSrcAbsolute() {
		return false;
	}

    private boolean normalizationRequired = true;

    private String normalizationPrefix = "<%= currentDesign.getPath() %>/";

    public void setNormalizationPrefix(String normalizationPrefix) {
	}

    public boolean isNormalizationRequired() {
		return false;
	}

    public void setNormalizationRequired(boolean normalizationRequired) {
	}

    @Override
    public void beginHandling(String uri, String localName, String qName, Attributes atts) {
	}

    @Override
    protected String getStartTag(String uri, String localName, String qName, Attributes atts) {
		return null;
	}

    protected boolean isAbsoluteUrl(String url) {
		return false;
	}
}