/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.foundation;

import com.day.cq.wcm.api.designer.Style;
import com.day.cq.wcm.foundation.Image;
import com.day.image.Layer;

import javax.jcr.RepositoryException;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Rectangle;

import java.io.IOException;

/**
 * Helper class for working with adaptive images.
 */
public class AdaptiveImageHelper {

    /**
     * Defines values for a number of common qualities.
     */
    public enum Quality {
        LOW(0.4), MEDIUM(0.82), HIGH(1.0);

        private double quality;

        Quality(double quality) {
            this.quality = quality;
        }
        public double getQualityValue() {
            return this.quality;
        }
    }

    /**
     * Lookup Quality value from a String.
     * @param imageQualityString
     * @return a Quality value for the requested String if it exists.
     */
    public static Quality getQualityFromString(String imageQualityString) {
		return null;
	}

    /**
     * Scales the given image to the dimensions specified by newWidth and newHeight. The scaling algorithm will
     * always scale the image in such a way that no white space will visible around the image. This means that
     * in any case where the dimensions are not the exact aspect ratio of the image, some cropping will occur.
     * Once the image has been cropped it will be adjusted so the center of the cropped dimension is still
     * centered.
     * @param image
     * @param newWidth
     * @param newHeight specify 0 to scale based on width and keep the current aspect ratio
     * @param style     style data including user defined crop and rotation
     * @return          scaled (and/or cropped) image layer
     * @throws RepositoryException
     * @throws IOException
     */
    public Layer scaleThisImage(Image image, int newWidth, int newHeight, Style style) throws RepositoryException, IOException {
		return null;
	}

    /**
     * Applies style data to the given image, including crop and rotation.
     * @param image
     * @param style
     * @return Layer with style data applied.
     * @throws RepositoryException
     * @throws IOException
     */
    public Layer applyStyleDataToImage(Image image, Style style) throws RepositoryException, IOException {
		return null;
	}

    /**
     * Renders a white rectangular layer with the given dimensions.
     * @param width
     * @param height
     * @return
     */
    public static Layer renderScaledPlaceholderImage(int width, int height) {
		return null;
	}

    private Layer renderScaledImageOnLayer(Layer layer, Dimension scaledSize, int newWidth, int newHeight) {
		return null;
	}
}
