/**
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 */
package com.day.cq.wcm.foundation;

import com.adobe.cq.sightly.WCMUsePojo;
import com.day.cq.wcm.api.NameConstants;
import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.components.Component;
import com.day.cq.wcm.api.designer.Design;
import com.day.cq.wcm.api.designer.Designer;
import com.day.cq.wcm.api.designer.Style;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Use API for the responsive grid sightly component
 * /libs/wcm/foundation/components/responsivegrid
 */
public class ResponsiveGrid extends WCMUsePojo {

    // default config
    private final String DEFAULT_CSS_PREFIX = "aem-Grid";

    private final int DEFAULT_COLUMNS = 12;

    // private
    private String cssClassPrefix;

    // exposed
    private int columns;

    private String cssClass;

    private List<Column> paragraphs = new ArrayList<Column>();

    /**
     * Class to get the necessary properties for a column in the grid
     */
    public class Column {

        private Resource resource;

        private String columnCssClassPrefix;

        public Column(Resource res) {
            resource = res;
            columnCssClassPrefix = cssClassPrefix + "Column";
        }

        public Resource getResource() {
			return null;
		}

        public String getPath() {
			return null;
		}

        public String getCssClass() {
			return null;
		}

        public ValueMap getProperties() {
			return null;
		}
    }

    @Override
    public void activate() throws Exception {
	}

    /**
     *
     * @return css classes to be added to the markup of the grid container
     */
    public String getCssClass() {
		return null;
	}

    /**
     *
     * @return all columns added to the grid
     */
    public List<Column> getParagraphs() {
		return null;
	}
}
