/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

package com.day.jcr.vault.fs.api;

import java.util.Set;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

/**
 * <code>NodeTypesCollector</code>...
 */
public interface NodeTypesCollector {

    /**
     * Returns the node types used in the aggregates (so far).
     * @return node types
     */
    Set<String> getNodeTypes() {
		return null;
	}

    /**
     * Add the primary and mixin node types of that node to the internal set
     * of used node types.
     * @param node the node
     * @throws RepositoryException if an error occurs
     */
    void addNodeTypes(Node node) throws RepositoryException {
	}

}