/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

package com.day.jcr.vault.fs.config;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Properties;

import com.day.jcr.vault.fs.api.VaultFsConfig;
import com.day.jcr.vault.fs.api.WorkspaceFilter;
import com.day.jcr.vault.fs.impl.JrVltNodeTypeSet;
import com.day.jcr.vault.fs.impl.JrVltNodeTypeSetAdapter;
import com.day.jcr.vault.fs.impl.JrVltVaultFsConfig;
import com.day.jcr.vault.fs.impl.JrVltVaultFsConfigAdapter;
import com.day.jcr.vault.fs.impl.JrVltWorkspaceFilter;
import com.day.jcr.vault.fs.spi.NodeTypeSet;
import com.day.jcr.vault.fs.spi.PrivilegeDefinitions;

/**
 * Abstracts the way of accessing the vault specific meta-info of a checkout.
 */
public class DefaultMetaInf implements MetaInf {

    private final org.apache.jackrabbit.vault.fs.config.DefaultMetaInf inf;

    public DefaultMetaInf() {
        this.inf = new org.apache.jackrabbit.vault.fs.config.DefaultMetaInf();
    }

    public DefaultMetaInf(org.apache.jackrabbit.vault.fs.config.DefaultMetaInf inf) {
        this.inf = inf;
    }

    /**
     * Returns the package format version of this package. If the package
     * lacks this information, {@link #FORMAT_VERSION_2} is returned, since this
     * feature was implemented recently.
     *
     * @return the package format version
     * @since 2.0
     */
    public int getPackageFormatVersion() {
		return 0;
	}

    public void loadFilter(InputStream in, String systemId) throws ConfigurationException, IOException {
	}

    public void loadConfig(InputStream in, String systemId) throws ConfigurationException, IOException {
	}

    public void loadSettings(InputStream in, String systemId) throws ConfigurationException, IOException {
	}

    public void loadProperties(InputStream in, String systemId) throws IOException {
	}

    public void loadPrivileges(InputStream in, String systemId) throws IOException {
	}

    public void save(File metaDir) throws IOException {
	}

    public VaultSettings getSettings() {
		return null;
	}

    public void setSettings(VaultSettings settings) {
	}

    public WorkspaceFilter getFilter() {
		return null;
	}

    public void setFilter(WorkspaceFilter filter) {
	}

    public VaultFsConfig getConfig() {
		return null;
	}

    public void setConfig(VaultFsConfig config) {
	}

    public Properties getProperties() {
		return null;
	}

    public void setProperties(Properties properties) {
	}

    public Collection<NodeTypeSet> getNodeTypes() {
		return null;
	}

    public PrivilegeDefinitions getPrivileges() {
		return null;
	}

    public void setCNDs(Collection<NodeTypeSet> cnds) {
	}

    public boolean hasDefinition() {
		return false;
	}

    public void setHasDefinition(boolean hasDefinition) {
	}
}