/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

package com.day.jcr.vault.fs.io;

import java.io.File;
import java.io.IOException;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

import com.day.jcr.vault.fs.api.ImportMode;
import com.day.jcr.vault.fs.api.ProgressTrackerListener;
import com.day.jcr.vault.fs.api.WorkspaceFilter;
import com.day.jcr.vault.fs.impl.CompatHelper;
import com.day.jcr.vault.fs.impl.JrVltProgressTrackerListener;
import com.day.jcr.vault.fs.impl.JrVltProgressTrackerListenerAdapter;
import com.day.jcr.vault.fs.impl.JrVltWorkspaceFilter;

/**
 * Option that control the package import.
 *
 * @since 2.3.12 (moved from com.day.jcr.packaging.ImportOptions)
 */
public class ImportOptions {

    private final JrVltImportOptions opts;

    public ImportOptions() {
        opts = new JrVltImportOptions();
    }

    public ImportOptions(ImportOptions base) {
        opts = base == null ? new JrVltImportOptions() : base.toJrVltImportOptions();
    }

    private ImportOptions(org.apache.jackrabbit.vault.fs.io.ImportOptions opts) {
        this.opts = new JrVltImportOptions(opts);
    }

    public static ImportOptions create(org.apache.jackrabbit.vault.fs.io.ImportOptions opts) {
		return null;
	}

    public boolean isStrict() {
		return false;
	}

    public void setAutoSaveThreshold(int threshold) {
	}

    public void setListener(ProgressTrackerListener listener) {
	}

    public int getAutoSaveThreshold() {
		return 0;
	}

    public File getPatchDirectory() {
		return null;
	}

    public ClassLoader getHookClassLoader() {
		return null;
	}

    public void setFilter(WorkspaceFilter filter) {
	}

    public String getPatchParentPath() {
		return null;
	}

    public void setImportMode(ImportMode importMode) {
	}

    public boolean isDryRun() {
		return false;
	}

    public void setDryRun(boolean dryRun) {
	}

    public void setNonRecursive(boolean nonRecursive) {
	}

    public void setPatchDirectory(File patchDirectory) throws IOException {
	}

    public ProgressTrackerListener getListener() {
		return null;
	}

    public void setAccessControlHandling(AccessControlHandling acHandling) {
	}

    public ImportMode getImportMode() {
		return null;
	}

    public void setPatchKeepInRepo(boolean patchKeepInRepo) {
	}

    public boolean isPatchKeepInRepo() {
		return false;
	}

    public void setPatchParentPath(String patchParentPath) {
	}

    public void setCndPattern(String cndPattern) throws PatternSyntaxException {
	}

    public AccessControlHandling getAccessControlHandling() {
		return null;
	}

    public WorkspaceFilter getFilter() {
		return null;
	}

    public Pattern getCndPattern() {
		return null;
	}

    public boolean isNonRecursive() {
		return false;
	}

    public void setHookClassLoader(ClassLoader hookClassLoader) {
	}

    public void setStrict(boolean strict) {
	}

    public JrVltImportOptions toJrVltImportOptions() {
		return null;
	}
}