/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

package com.day.jcr.vault.fs.io;

import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;

import javax.jcr.Binary;
import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.RepositoryException;

import com.day.jcr.vault.fs.api.Artifact;
import com.day.jcr.vault.fs.api.VaultFile;
import com.day.jcr.vault.util.JcrConstants;
import com.day.jcr.vault.util.PathUtil;
import com.day.jcr.vault.util.PlatformNameFormat;
import com.day.jcr.vault.util.Text;

/**
 * Implements a Vault filesystem exporter that exports Vault files to a JCR
 * repository.
 * It uses the {@link PlatformNameFormat} for formatting the jcr file
 * names to local ones.
 */
public class JcrExporter extends AbstractExporter {

    private final Node localParent;

    private boolean autoDeleteFiles;

    /**
     * Constructs a new jcr exporter.
     * @param localFile the local parent folder
     */
    public JcrExporter(Node localFile) {
        this.localParent = localFile;
    }

    public boolean isAutoDeleteFiles() {
		return false;
	}

    public void setAutoDeleteFiles(boolean autoDeleteFiles) {
	}

    /**
     * {@inheritDoc}
     */
    public void open() throws IOException, RepositoryException {
	}

    /**
     * {@inheritDoc}
     */
    public void close() throws IOException, RepositoryException {
	}

    private void scan(Node dir) throws RepositoryException {
	}

    public void createDirectory(VaultFile file, String relPath)
            throws RepositoryException, IOException {
			}

    public void createDirectory(String relPath) throws IOException {
	}

    public void writeFile(VaultFile file, String relPath)
            throws RepositoryException, IOException {
			}

    public void writeFile(InputStream in, String relPath) throws IOException {
	}

    private Node getOrCreateItem(String relPath, boolean isDir) throws IOException {
		return null;
	}

}