/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

package com.day.jcr.vault.packaging;

import java.util.ArrayList;
import java.util.List;

/**
 * Implements a package dependency reference.
 *
 * @since 2.0
 * @deprecated since 2.5.0. Use the org.apache.jackrabbit.vault API instead.
 */
@Deprecated
public class Dependency {

    /**
     * An empty dependency array
     */
    public static final Dependency[] EMPTY = new Dependency[0];

    /**
     * group id of the dependency
     */
    private final String groupId;

    /**
     * name of the dependency
     */
    private final String name;

    /**
     * Version range of the dependency
     */
    private final VersionRange range;

    /**
     * internal string representation
     */
    private final String str;

    /**
     * Creates a new dependency reference.
     * @param groupId group id
     * @param name name
     * @param range version range
     */
    public Dependency(String groupId, String name, VersionRange range) {
        if (groupId.startsWith(PackageId.ETC_PACKAGES_PREFIX)) {
            groupId = groupId.substring(PackageId.ETC_PACKAGES_PREFIX.length());
        }
        this.groupId = groupId;
        this.name = name;
        this.range = range == null ? VersionRange.INFINITE : range;
        StringBuilder b = new StringBuilder();
        if (groupId.length() > 0 || !VersionRange.INFINITE.equals(this.range)) {
            b.append(groupId);
            b.append(":");
        }
        b.append(name);
        if (!VersionRange.INFINITE.equals(this.range)) {
            b.append(":");
            b.append(range);
        }
        this.str = b.toString();
    }

    /**
     * Creates a new dependency to the specified package id
     * @param id package id.
     */
    public Dependency(PackageId id) {
        this(id.getGroup(), id.getName(), new VersionRange(id.getVersion()));
    }

    /**
     * Returns the group id of the dependency
     * @return the group id
     * @deprecated since 2.4. use {@link #getGroup()} instead.
     */
    public String getGroupId() {
		return null;
	}

    /**
     * Returns the group of the dependency
     * @return the group id
     * @since 2.4
     */
    public String getGroup() {
		return null;
	}

    /**
     * Returns the name of the dependency
     * @return the name
     */
    public String getName() {
		return null;
	}

    /**
     * Returns the version range
     * @return the version range
     */
    public VersionRange getRange() {
		return null;
	}

    /**
     * Returns the installation path of this dependency
     * @return the installation path;
     */
    public String getPath() {
		return null;
	}

    /**
     * Checks if the given package id matches this dependency specification.
     * @param id the package id
     * @return <code>true</code> if matches
     */
    public boolean matches(PackageId id) {
		return false;
	}

    /**
     * Returns a dependency from a string. if the given id is null or an
     * empty string, <code>null</code> is returned.
     * @param str the string
     * @return the dependency
     */
    public static Dependency fromString(String str) {
		return null;
	}

    /**
     * Parses a string serialization of dependency references generated by
     * {@link #toString(Dependency...)})}
     *
     * @param str serialized string
     * @return array of dependency references
     */
    public static Dependency[] parse(String str) {
		return null;
	}
    
    /**
     * Returns dependencies from the given strings.
     * @param str the strings
     * @return the dependencies
     */
    public static Dependency[] fromString(String ... str) {
		return null;
	}

    /**
     * Returns a string representation from given dependencies.
     * @param deps the dependencies
     * @return the strings
     */
    public static String toString(Dependency ... deps) {
		return null;
	}

    @Override
    public String toString() {
		return null;
	}

    @Override
    public boolean equals(Object obj) {
		return false;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    public static org.apache.jackrabbit.vault.packaging.Dependency toJrVltDependency(Dependency dep) {
		return null;
	}
    public static org.apache.jackrabbit.vault.packaging.Dependency[] toJrVltDependencies(Dependency[] deps) {
		return null;
	}
    public static Dependency[] create(org.apache.jackrabbit.vault.packaging.Dependency[] deps) {
		return null;
	}

    public static Dependency create(org.apache.jackrabbit.vault.packaging.Dependency dep) {
		return null;
	}
 }