/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

package com.day.jcr.vault.util;

import java.io.IOException;
import java.io.InputStream;

/**
 * Provides an input stream wrapper that detects line feed sequences and 
 * replaces them by new ones.
 *
 */
public class LineInputStream extends InputStream {

    public static final byte[] LS_UNIX = new byte[]{0x0a};

    public static final byte[] LS_WINDOWS = new byte[]{0x0d, 0x0a};

    public static final byte[] LS_NATIVE = System.getProperty("line.separator").getBytes();

    private byte[] buffer = new byte[8192];

    private byte[] lineFeed = LS_NATIVE;

    private byte[] lineSpool;

    private int pos = 0;

    private int end = 0;

    private static final char STATE_INIT = ' ';
    private static final char STATE_CR = 'c';
    private static final char STATE_LF = 'l';
    private static final char STATE_CRLF = 'f';

    private char state = STATE_INIT;

    boolean isEof = false;

    private byte[] spool;

    private int spoolPos = 0;

    private final InputStream in;

    public LineInputStream(InputStream in, byte[] ls) {
        this.in = in;
        if (ls != null) {
            lineFeed = ls;
        }
        lineSpool = new byte[lineFeed.length + 1];
        System.arraycopy(lineFeed, 0, lineSpool, 0, lineFeed.length);
    }

    private int fillBuffer() throws IOException {
		return 0;
	}

    public int read() throws IOException {
		return 0;
	}

    public int read(byte b[], int off, int len) throws IOException {
		return 0;
	}

    public void close() throws IOException {
	}

}