/*
 * $Id: TimeZoneUtil.java 12345 2004-08-22 04:56:09Z fielding $
 *
 * Copyright 1997-2004 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */

package com.day.util;

import java.util.*;
import java.text.DecimalFormat;

/**
 * The <code>TimeZoneUtil</code> class provides convenience methods for handling
 * time zones in Java.
 *
 * @version $Revision: 1.3 $, $Date: 2004-08-22 06:56:09 +0200 (Sun, 22 Aug 2004) $
 * @author mreutegg
 * @since echidna
 * @audience wad
 */
public class TimeZoneUtil {

    private static TimeZone[] zones = null;

    private static final DecimalFormat offsetFormatter = new DecimalFormat("00.00");

    /**
     * Returns an array of <code>TimeZone</code> objects sorted in ascending order
     * by their UTC time offset.
     *
     * @return a sorted array of <code>TimeZone</code> objects.
     */
    public synchronized static TimeZone[] getAvailableZones() {
		return null;
	}

    /**
     * Returns the <code>TimeZone</code> of the Communiqu server.
     * @return the <code>TimeZone</code> of the Communiqu server.
     */
    public static TimeZone getServerTimeZone() {
		return null;
	}

    /**
     * Formats the passed <code>TimeZone</code> object to a String representation:
     * <p><code>[&lt;UTC offset&gt;] &lt;time zone name&gt; (&lt;short name&gt;)</code>
     * <p>Example: [UTC+01.00] Europe/Berlin (CEST)

     * @param zone The <code>TimeZone</code> to format
     * @return a <code>String</code> representation of the passed <code>TimeZone</code>.
     */
    public static String getDisplayName(TimeZone zone) {
		return null;
	}

    /**
     * Inner utility class for comparing two TimeZone objects regarding their UTC
     * offset.
     */
    static class TimeZoneComparator implements Comparator {

        /**
         * Compares its two arguments (TimeZone objects) for order.
         *
         * @param o1 the first object to be compared.
         * @param o2 the second object to be compared.
         * @return a negative integer, zero, or a positive integer as the
         * 	       first argument is less than, equal to, or greater than the
         *	       second.
         * @throws ClassCastException if the arguments' types prevent them from
         * 	       being compared by this Comparator.
         */
        public int compare(Object o1, Object o2) {
			return 0;
		}
    }
}
