/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/
package io.sightly.java.api;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import javax.script.Bindings;
import javax.script.SimpleBindings;

/**
 * Compiled version of render units.
 * <p>
 * This abstract class was previsouly used as the base class for Sightly
 * templates translated to Java classes. With the move from Sightly to Apache
 * Sling this class is not used any longer. Non-Sightly implementations of this
 * class are ignored.
 *
 * @deprecated as of bundle version 1.1.68 without replacement. Implementations
 *             of this interface are not used and thus ignored by the Sling
 *             Sightly engine.
 */
@Deprecated
public abstract class BaseRenderUnit implements RenderUnit {

    private final Map<String, RenderUnit> subTemplates = new HashMap<String, RenderUnit>();

    private Map<String, RenderUnit> siblings;

    @Override
    public final void render(RenderContext renderContext, Bindings arguments) {
	}

    @Override
    public RenderUnit get(String name) {
		return null;
	}

    @Override
    public Set<String> properties() {
		return null;
	}

    protected abstract void render(StackedWriter writer,
                                   Bindings bindings,
                                   Bindings arguments,
                                   ObjectModel dynamic,
                                   SightlyRuntime runtime,
                                   RenderContext renderContext) {
	}

    @SuppressWarnings({"unused", "unchecked"})
    protected void callUnit(RenderContext renderContext, Object templateObj, Object argsObj) {
	}

    @SuppressWarnings("UnusedDeclaration")
    protected FluentMap obj() {
		return null;
	}

    protected final void addSubTemplate(String name, BaseRenderUnit renderUnit) {
	}

    private void setSiblings(Map<String, RenderUnit> siblings) {
	}

    private Bindings buildGlobalScope(Bindings bindings) {
		return null;
	}

    protected static class FluentMap extends HashMap<String, Object> {

        /**
         * Fluent variant of put
         * @param name - the name of the property
         * @param value - the value of the property
         * @return - this instance
         */
        public FluentMap with(String name, Object value) {
			return null;
		}

    }

    private static final class CaseInsensitiveBindings extends SimpleBindings {

        private CaseInsensitiveBindings(Map<String, Object> m) {
            for (Map.Entry<String, Object> entry : m.entrySet()) {
                put(entry.getKey().toLowerCase(), entry.getValue());
            }
        }

        @Override
        public Object get(Object key) {
			return null;
		}

        @Override
        public boolean containsKey(Object key) {
			return false;
		}
    }

}
