/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.commons.packaging;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.NoSuchElementException;

import javax.jcr.Item;
import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.PropertyIterator;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.jackrabbit.commons.predicate.Predicate;

public class FilterContentPackage implements ContentPackage {

    protected final List<Content> content = new ArrayList<Content>();

    protected boolean includeProperties = false;

    public void addContent(String path, Predicate filterList) {
	}

    public void addContent(String[] paths, Predicate filterList) {
	}

    /**
     * @see org.apache.jackrabbit.commons.packaging.ContentPackage#getItems(javax.jcr.Session)
     */
    public Iterator<Item> getItems(Session session)
    throws RepositoryException {
		return null;
	}

    protected static class Content {
        protected final String[] paths;
        protected final Predicate filterList;

        public Content(String[] paths, Predicate filterList) {
            this.paths = paths;
            this.filterList = filterList;
        }
    }

    public static class FilteringIterator implements Iterator {

        /** The content we will iterate over. */
        protected final List<Content> content;

        /**
         * Filter that defines which items are included
         */
        protected Predicate includeFilter;

        protected int contentIndex, pathIndex;

        protected Item nextItem;

        protected Node lastNode;

        protected final Session session;

        protected final List<NodeIterator> nodeIteratorStack = new ArrayList<NodeIterator>();

        protected final boolean includeProperties;

        protected PropertyIterator propertyIterator;

        /**
         * Creates a new tree walker that uses the given filter as include and
         * traversal filter.
         *
         * @param session The session.
         * @param contentList The list of content objects.
         * @param includeProperties Should properties be included.
         */
        public FilteringIterator(final Session session,
                                 final List<Content> contentList,
                                 final boolean includeProperties) {
            this.content = contentList;
            this.session = session;
            this.includeProperties = includeProperties;
        }

        /**
         * @see java.util.Iterator#hasNext()
         */
        public boolean hasNext() {
			return false;
		}

        protected boolean checkForNextNode() throws RepositoryException {
			return false;
		}

        /**
         * @see java.util.Iterator#next()
         */
        public Object next() {
			return null;
		}

        /**
         * @see java.util.Iterator#remove()
         */
        public void remove() {
		}
    }

    public boolean isIncludeProperties() {
		return false;
	}

    public void setIncludeProperties(boolean includeProperties) {
	}
}
