/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.oak.commons.jmx;

import javax.management.DescriptorRead;
import javax.management.MBeanAttributeInfo;
import javax.management.MBeanInfo;
import javax.management.MBeanOperationInfo;
import javax.management.MBeanParameterInfo;
import javax.management.StandardMBean;

/**
 * The extension of {@link javax.management.StandardMBean} that will automatically provide JMX
 * metadata through annotations.
 *
 * @see javax.management.MBeanInfo
 * @see Description
 * @see Name
 * @see Impact
 */
public class AnnotatedStandardMBean extends StandardMBean {
    /**
     * Make a DynamicMBean out of the object implementation, using the specified
     * mbeanInterface class.
     *
     * @see {@link javax.management.StandardMBean#StandardMBean(Object, Class)}
     */
    public <T> AnnotatedStandardMBean(T implementation, Class<T> mbeanInterface){
        super(implementation, mbeanInterface, false);
    }

    protected AnnotatedStandardMBean(Class<?> mbeanInterface){
        super(mbeanInterface, false);
    }

    @Override
    protected String getDescription(MBeanInfo info) {
		return null;
	}

    @Override
    protected String getDescription(MBeanAttributeInfo info) {
		return null;
	}

    @Override
    protected String getDescription(MBeanOperationInfo info) {
		return null;
	}

    @Override
    protected int getImpact(MBeanOperationInfo info) {
		return 0;
	}

    @Override
    protected String getParameterName(MBeanOperationInfo op,
                                      MBeanParameterInfo param, int sequence) {
										return null;
									}

    @Override
    protected String getDescription(MBeanOperationInfo op,
                                    MBeanParameterInfo param, int sequence) {
										return null;
									}

    private static String getValue(DescriptorRead dr, String fieldName){
		return null;
	}
}
