/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.commons.json;

/**
 * A tokenizer for Json and Jsop strings.
 */
public class JsopTokenizer implements JsopReader {

    private static final String[] TYPE = {
            "end", "string", "number", "true", "false", "null", "error"
    };

    private final String jsop;
    private final int length;
    private int lastPos;
    private int pos;
    private int currentType;
    private boolean currentEscaped;
    private String currentToken;
    private int lastType;
    private String lastToken;
    private boolean lastEscaped;

    public JsopTokenizer(String json, int pos) {
        this.jsop = json;
        this.length = json.length();
        this.pos = pos;
        read();
    }

    public JsopTokenizer(String json) {
        this(json, 0);
    }

    @Override
    public void resetReader() {
	}

    @Override
    public String toString() {
		return null;
	}

    /**
     * Get the token type of the last token.
     *
     * @return the token type
     */
    @Override
    public int getTokenType() {
		return 0;
	}

    /**
     * Get the last token value if the the token type was STRING or NUMBER. For
     * STRING, the text is decoded; for NUMBER, it is returned as parsed. In all
     * other cases the result is undefined.
     *
     * @return the token
     */
    @Override
    public String getToken() {
		return null;
	}

    /**
     * Get the last encoded (raw) string, including escape sequences.
     *
     * @return the encoded string
     */
    public String getEscapedToken() {
		return null;
	}

    /**
     * Read a token which must match a given token type.
     *
     * @param type the token type
     * @return the token (a null object when reading a null value)
     * @throws IllegalStateException if the token type doesn't match
     */
    @Override
    public String read(int type) {
		return null;
	}

    private void skip(int type) {
	}

    /**
     * Read a string.
     *
     * @return the de-escaped string
     * @throws IllegalStateException if the token type doesn't match
     */
    @Override
    public String readString() {
		return null;
	}

    /**
     * Read a token which must match a given token type.
     *
     * @param type the token type
     * @return true if there was a match
     */
    @Override
    public boolean matches(int type) {
		return false;
	}

    /**
     * Read a token and return the token type.
     *
     * @return the token type
     */
    @Override
    public int read() {
		return 0;
	}

    private int readToken() {
		return 0;
	}

    /**
     * Decode a quoted Json string.
     *
     * @param s the encoded string, with double quotes
     * @return the string
     */
    public static String decodeQuoted(String s) {
		return null;
	}

    /**
     * Decode a Json string.
     *
     * @param s the encoded string, without double quotes
     * @return the string
     */
    public static String decode(String s) {
		return null;
	}

    private static String getTokenType(int type) {
		return null;
	}

    private static IllegalArgumentException getFormatException(String s, int i, String expected) {
		return null;
	}

    private static IllegalArgumentException getFormatException(String s, int i) {
		return null;
	}

    /**
     * Add an asterisk ('[*]') at the given position. This format is used to
     * show where parsing failed in a statement.
     *
     * @param s the text
     * @param index the position
     * @return the text with asterisk
     */
    private static String addAsterisk(String s, int index) {
		return null;
	}

    /**
     * Read a value and return the raw Json representation. This includes arrays
     * and nested arrays.
     *
     * @return the Json representation of the value
     */
    @Override
    public String readRawValue() {
		return null;
	}

    private void skipRawValue() {
	}

    public int getPos() {
		return 0;
	}

    public int getLastPos() {
		return 0;
	}

    public void setPos(int pos) {
	}

}
