/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.jackrabbit.oak.commons.sort;

import javax.annotation.Nullable;


import static com.google.common.base.Preconditions.checkState;

/**
 * Utility class to escape '\n', '\r', '\' char
 * while being written to file and unescape then upon getting
 * read from file. This is used by StringSort and ExternalSort
 * to handle data which contains line break. If left unescaped
 * then such data interferes with the processing of such utilities
 */
abstract class EscapeUtils {

    static String escapeLineBreak(@Nullable String line) {
		return null;
	}

    static String unescapeLineBreaks(@Nullable String line) {
		return null;
	}

    private static boolean escapingRequired(String line) {
		return false;
	}

    private static boolean unescapingRequired(String line) {
		return false;
	}

    private static String escape(String line) {
		return null;
	}

    private static String unescape(String line) {
		return null;
	}

}
