/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.plugins.segment;

import static com.google.common.base.Charsets.UTF_8;
import static com.google.common.collect.Sets.newHashSet;
import static java.util.Collections.emptySet;
import static org.apache.jackrabbit.oak.plugins.segment.Segment.MEDIUM_LIMIT;
import static org.apache.jackrabbit.oak.plugins.segment.Segment.SMALL_LIMIT;
import static org.apache.jackrabbit.oak.plugins.segment.SegmentWriter.BLOCK_SIZE;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Set;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;

import org.apache.jackrabbit.oak.api.Blob;
import org.apache.jackrabbit.oak.plugins.memory.AbstractBlob;
import org.apache.jackrabbit.oak.spi.blob.BlobStore;

/**
 * A BLOB (stream of bytes). This is a record of type "VALUE".
 */
public class SegmentBlob extends Record implements Blob {

    public static Iterable<SegmentId> getBulkSegmentIds(Blob blob) {
		return null;
	}

    SegmentBlob(RecordId id) {
        super(id);
    }

    private InputStream getInlineStream(
            Segment segment, int offset, int length) {
				return null;
			}

    @Override @Nonnull
    public InputStream getNewStream() {
		return null;
	}

    @Override
    public long length() {
		return 0L;
	}

    @Override
    @CheckForNull
    public String getReference() {
		return null;
	}


    @Override
    public String getContentIdentity() {
		return null;
	}

    public boolean isExternal() {
		return false;
	}

    public String getBlobId() {
		return null;
	}

    public SegmentBlob clone(SegmentWriter writer, boolean cloneLargeBinaries) throws IOException {
		return null;
	}

    //------------------------------------------------------------< Object >--

    @Override
    public boolean equals(Object object) {
		return false;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    //-----------------------------------------------------------< private >--

    private static String readShortBlobId(Segment segment, int offset, byte head) {
		return null;
	}

    private static String readLongBlobId(Segment segment, int offset) {
		return null;
	}

    private Iterable<SegmentId> getBulkSegmentIds() {
		return null;
	}

    private Blob getBlob(String blobId) {
		return null;
	}

    private InputStream getNewStream(String blobId) {
		return null;
	}

    private long getLength(String blobId) {
		return 0L;
	}

}
