/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.spi.commit;

import static com.google.common.base.Preconditions.checkNotNull;
import static java.util.Arrays.asList;

import org.apache.jackrabbit.oak.api.CommitFailedException;
import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.spi.state.NodeState;

import com.google.common.collect.Lists;

import java.util.Collection;
import java.util.List;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;

/**
 * Aggregation of a list of editors into a single editor.
 */
public class CompositeEditor implements Editor {

    @CheckForNull
    public static Editor compose(@Nonnull Collection<? extends Editor> editors) {
		return null;
	}

    private final Collection<? extends Editor> editors;

    public CompositeEditor(Collection<? extends Editor> editors) {
        this.editors = editors;
    }

    public CompositeEditor(Editor... editors) {
        this(asList(editors));
    }

    @Override
    public void enter(NodeState before, NodeState after)
            throws CommitFailedException {
			}

    @Override
    public void leave(NodeState before, NodeState after)
            throws CommitFailedException {
			}


    @Override
    public void propertyAdded(PropertyState after)
            throws CommitFailedException {
			}

    @Override
    public void propertyChanged(PropertyState before, PropertyState after)
            throws CommitFailedException {
			}

    @Override
    public void propertyDeleted(PropertyState before)
            throws CommitFailedException {
			}

    @Override
    public Editor childNodeAdded(String name, NodeState after)
            throws CommitFailedException {
				return null;
			}

    @Override
    public Editor childNodeChanged(
            String name, NodeState before, NodeState after)
            throws CommitFailedException {
				return null;
			}

    @Override
    public Editor childNodeDeleted(String name, NodeState before)
            throws CommitFailedException {
				return null;
			}

}
