/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.jackrabbit.oak.spi.commit;

import static org.apache.jackrabbit.oak.commons.PathUtils.concat;

import javax.annotation.CheckForNull;
import javax.annotation.Nullable;

import com.google.common.base.Function;
import org.apache.jackrabbit.oak.api.CommitFailedException;
import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.spi.state.NodeState;
import org.slf4j.Logger;

/**
 * This {@code Editor} instance logs invocations to the logger
 * passed to its constructor after each 10000 calls to it
 * {@code enter()} method.
 */
public class ProgressNotificationEditor implements Editor {
    private final Editor editor;
    private final String path;
    private final Function<String, Void> onProgress;

    @CheckForNull
    public static Editor wrap(@CheckForNull Editor editor, final Logger logger, final String message) {
		return null;
	}

    private ProgressNotificationEditor(Editor editor, String path, Function<String, Void> onProgress) {
        this.editor = editor;
        this.path = path;
        this.onProgress = onProgress;
    }

    @Override
    public void enter(NodeState before, NodeState after) throws CommitFailedException {
	}

    @Override
    public void leave(NodeState before, NodeState after) throws CommitFailedException {
	}

    @Override
    public void propertyAdded(PropertyState after) throws CommitFailedException {
	}

    @Override
    public void propertyChanged(PropertyState before, PropertyState after) throws CommitFailedException {
	}

    @Override
    public void propertyDeleted(PropertyState before) throws CommitFailedException {
	}

    @Override
    public Editor childNodeAdded(String name, NodeState after) throws CommitFailedException {
		return null;
	}

    @Override
    public Editor childNodeChanged(String name, NodeState before, NodeState after) throws CommitFailedException {
		return null;
	}

    @Override
    public Editor childNodeDeleted(String name, NodeState before) throws CommitFailedException {
		return null;
	}

    private ProgressNotificationEditor createChildEditor(Editor editor, String name) {
		return null;
	}
}
