/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.rmi.client;

import java.rmi.RemoteException;

import javax.jcr.RepositoryException;
import javax.jcr.UnsupportedRepositoryOperationException;
import javax.jcr.nodetype.NodeDefinitionTemplate;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeDefinition;
import javax.jcr.nodetype.NodeTypeIterator;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.NodeTypeTemplate;
import javax.jcr.nodetype.PropertyDefinitionTemplate;

import org.apache.jackrabbit.rmi.remote.RemoteNodeTypeManager;

/**
 * Local adapter for the JCR-RMI
 * {@link org.apache.jackrabbit.rmi.remote.RemoteNodeTypeManager RemoteNodeTypeManager}
 * interface. This class makes a remote node type manager locally available
 * using the JCR {@link javax.jcr.nodetype.NodeTypeManager NodeTypeManager}
 * interface.
 *
 * @see javax.jcr.nodetype.NodeTypeManager
 * @see org.apache.jackrabbit.rmi.remote.RemoteNodeTypeManager
 */
public class ClientNodeTypeManager extends ClientObject
        implements NodeTypeManager {

    /** The adapted remote node type manager. */
    private RemoteNodeTypeManager remote;

    /**
     * Creates a local adapter for the given remote node type manager.
     *
     * @param remote remote node type manager
     * @param factory local adapter factory
     */
    public ClientNodeTypeManager(
            RemoteNodeTypeManager remote, LocalAdapterFactory factory) {
        super(factory);
        this.remote = remote;
    }

    /** {@inheritDoc} */
    public NodeType getNodeType(String name) throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public NodeTypeIterator getAllNodeTypes() throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public NodeTypeIterator getPrimaryNodeTypes() throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public NodeTypeIterator getMixinNodeTypes() throws RepositoryException {
		return null;
	}

    public NodeDefinitionTemplate createNodeDefinitionTemplate()
            throws RepositoryException {
				return null;
			}

    public NodeTypeTemplate createNodeTypeTemplate()
            throws RepositoryException {
				return null;
			}

    public NodeTypeTemplate createNodeTypeTemplate(NodeTypeDefinition ntd)
            throws RepositoryException {
				return null;
			}

    public PropertyDefinitionTemplate createPropertyDefinitionTemplate()
            throws RepositoryException {
				return null;
			}

    public boolean hasNodeType(String name) throws RepositoryException {
		return false;
	}

    public NodeType registerNodeType(
            NodeTypeDefinition ntd, boolean allowUpdate)
            throws RepositoryException {
				return null;
			}

    public NodeTypeIterator registerNodeTypes(
            NodeTypeDefinition[] ntds, boolean allowUpdate)
            throws RepositoryException {
				return null;
			}

    public void unregisterNodeType(String name) throws RepositoryException {
	}

    public void unregisterNodeTypes(String[] names) throws RepositoryException {
	}

}
