/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.rmi.client;

import java.rmi.RemoteException;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.version.Version;
import javax.jcr.version.VersionHistory;
import javax.jcr.version.VersionManager;

import org.apache.jackrabbit.rmi.remote.RemoteIterator;
import org.apache.jackrabbit.rmi.remote.RemoteNode;
import org.apache.jackrabbit.rmi.remote.RemoteVersionManager;

public class ClientVersionManager extends ClientObject
        implements VersionManager {

    /** The current session. */
    private Session session;

    private RemoteVersionManager remote;

    public ClientVersionManager(
            Session session, RemoteVersionManager remote,
            LocalAdapterFactory factory) {
        super(factory);
        this.session = session;
        this.remote = remote;
    }

    /** {@inheritDoc} */
    public void cancelMerge(String absPath, Version version)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public Version checkin(String absPath) throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public void checkout(String absPath) throws RepositoryException {
	}

    /** {@inheritDoc} */
    public Version checkpoint(String absPath) throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public Node createActivity(String title)
            throws RepositoryException {
				return null;
			}

    /** {@inheritDoc} */
    public Node createConfiguration(String absPath)
            throws RepositoryException {
				return null;
			}

    /** {@inheritDoc} */
    public void doneMerge(String absPath, Version version)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public Node getActivity() throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public Version getBaseVersion(String absPath) throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public VersionHistory getVersionHistory(String absPath)
            throws RepositoryException {
				return null;
			}

    /** {@inheritDoc} */
    public boolean isCheckedOut(String absPath) throws RepositoryException {
		return false;
	}

    /** {@inheritDoc} */
    public NodeIterator merge(Node activityNode) throws RepositoryException {
		return null;
	}

    /** {@inheritDoc} */
    public NodeIterator merge(
            String absPath, String srcWorkspace, boolean bestEffort)
            throws RepositoryException {
				return null;
			}

    /** {@inheritDoc} */
    public NodeIterator merge(
            String absPath, String srcWorkspace, boolean bestEffort,
            boolean isShallow) throws RepositoryException {
				return null;
			}

    /** {@inheritDoc} */
    public void removeActivity(Node activityNode) throws RepositoryException {
	}

    /** {@inheritDoc} */
    public void restore(Version[] versions, boolean removeExisting)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public void restore(Version version, boolean removeExisting)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public void restore(
            String absPath, String versionName, boolean removeExisting)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public void restore(String absPath, Version version, boolean removeExisting)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public void restoreByLabel(
            String absPath, String versionLabel, boolean removeExisting)
            throws RepositoryException {
			}

    /** {@inheritDoc} */
    public Node setActivity(Node activity) throws RepositoryException {
		return null;
	}

}
