/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.name;

import javax.jcr.RepositoryException;

import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.Path;

final class IdentifierPath extends AbstractPath {

    /** Serial version UID */
    private static final long serialVersionUID = 1602959709588338642L;

    private final String identifier;

    public IdentifierPath(String identifier) {
        assert identifier != null;
        this.identifier = identifier;
    }

    /**
     * Returns <code>null</code> as an identifier element has no name.
     *
     * @return <code>null</code>
     */
    public Name getName() {
		return null;
	}

    public String getIdentifier() {
		return null;
	}

    /**
     * Returns <code>true</code> as this is an identifier-based path.
     *
     * @return <code>true</code>
     */
    @Override
    public boolean denotesIdentifier() {
		return false;
	}

    /**
     * Returns <code>true</code> as this is an identifier-based path.
     *
     * @return <code>true</code>
     */
    public boolean isIdentifierBased() {
		return false;
	}

    /**
     * Returns <code>true</code> as an identifier-based path with no other
     * elements is absolute.
     *
     * @return <code>true</code>
     */
    public boolean isAbsolute() {
		return false;
	}

    /**
     * Returns <code>true</code> as an identifier-based path with no other
     * elements is canonical.
     *
     * @return <code>true</code>
     */
    public boolean isCanonical() {
		return false;
	}

    /**
     * Returns <code>false</code> as an identifier-based path is never
     * normalized.
     *
     * @return <code>false</code>
     */
    public boolean isNormalized() {
		return false;
	}

    public Path getNormalizedPath() throws RepositoryException {
		return null;
	}

    public Path getCanonicalPath() {
		return null;
	}

    public Path getAncestor(int degree)
            throws IllegalArgumentException, RepositoryException {
				return null;
			}

    public int getAncestorCount() {
		return 0;
	}

    public int getLength() {
		return 0;
	}

    public int getDepth() {
		return 0;
	}

    public Path subPath(int from, int to) throws IllegalArgumentException {
		return null;
	}

    public Element[] getElements() {
		return null;
	}

    public String getString() {
		return null;
	}

    //--------------------------------------------------------------< Object >

    public final boolean equals(Object that) {
		return false;
	}

    public final int hashCode() {
		return 0;
	}

}
