/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.nodetype;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.jackrabbit.spi.QNodeTypeDefinition;
import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.QPropertyDefinition;
import org.apache.jackrabbit.spi.QNodeDefinition;
import org.apache.jackrabbit.spi.commons.conversion.NamePathResolver;

import javax.jcr.nodetype.NodeTypeDefinition;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.NamespaceException;
import javax.jcr.ValueFactory;

/**
 * <code>AbstractNodeTypeDefinition</code>...
 */
public class NodeTypeDefinitionImpl implements NodeTypeDefinition {

    /**
     * logger instance
     */
    private static final Logger log = LoggerFactory.getLogger(NodeTypeDefinitionImpl.class);

    protected final QNodeTypeDefinition ntd;
    private final NamePathResolver resolver;
    private final ValueFactory valueFactory;

    /**
     * 
     * @param ntd
     * @param resolver
     * @param valueFactory
     */
    public NodeTypeDefinitionImpl(QNodeTypeDefinition ntd, NamePathResolver resolver,
                                  ValueFactory valueFactory) {
        this.ntd = ntd;
        this.resolver = resolver;
        this.valueFactory = valueFactory;
    }

    //-------------------------------------------------< NodeTypeDefinition >---
    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#getName()
     */
    public String getName() {
		return null;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#getPrimaryItemName()
     */
    public String getPrimaryItemName() {
		return null;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#isMixin()
     */
    public boolean isMixin() {
		return false;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#hasOrderableChildNodes()
     */
    public boolean hasOrderableChildNodes() {
		return false;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#isAbstract()
     */
    public boolean isAbstract() {
		return false;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#isQueryable()
     */
    public boolean isQueryable() {
		return false;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#getDeclaredPropertyDefinitions()
     */
    public PropertyDefinition[] getDeclaredPropertyDefinitions() {
		return null;
	}


    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#getDeclaredChildNodeDefinitions()
     */
    public NodeDefinition[] getDeclaredChildNodeDefinitions() {
		return null;
	}

    /**
     * @see javax.jcr.nodetype.NodeTypeDefinition#getDeclaredSupertypeNames()
     */
    public String[] getDeclaredSupertypeNames() {
		return null;
	}
}