/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jackrabbit.vault.fs.config;

import java.io.File;
import java.io.IOException;

import org.apache.jackrabbit.vault.util.Constants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Represents the root of a vault export or a vlt checkout. it has the following
 * structure:
 *
 * <xmp>
 * root
 * |-- META-INF
 * |   `-- vault
 * |       |-- config.xml
 * |       |-- filter.xml
 * |       |-- nodetypes.cnd
 * |       `-- properties.xml
 * `-- jcr_root
 *     :
 * </xmp>
 *
 */
public class ExportRoot {

    private static final Logger log = LoggerFactory.getLogger(ExportRoot.class);

    private final File rootDir;

    private final File jcrRoot;

    private final File metaDir;

    private DefaultMetaInf metaInf;

    public ExportRoot(File rootDir) {
        this.rootDir = rootDir;
        this.jcrRoot = new File(rootDir, Constants.ROOT_DIR);
        this.metaDir = new File(rootDir, Constants.META_DIR);
    }

    /**
     * Checks if this export root already has the necessary structure setup.
     * @return <code>true</code> if valid.
     */
    public boolean isValid() {
		return false;
	}

    public void assertValid() throws IOException {
	}

    /**
     * Creates the necessary directories if they do not exist yet.
     * @throws IOException if an I/O error occurs
     */
    public void create() throws IOException {
	}

    /**
     * Returns the meta information.
     * @return the meta information.
     */
    public MetaInf getMetaInf() {
		return null;
	}

    public File getRoot() {
		return null;
	}

    public File getJcrRoot() {
		return null;
	}

    public File getMetaDir() {
		return null;
	}

    public static ExportRoot findRoot(File cwd) {
		return null;
	}

}