/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.sling.api.request;

import java.io.IOException;
import java.io.Writer;

import javax.annotation.Nonnull;

/**
 * Response related utility methods
 * <p>
 * This class is not intended to be extended or instantiated because it just
 * provides static utility methods not intended to be overwritten.
 *
 * @since 2.1 (Sling API Bundle 2.1.0)
 */
public class ResponseUtil {

    private static class XmlEscapingWriter extends Writer {
        private final Writer target;

        XmlEscapingWriter(Writer target) {
            this.target = target;
        }

        @Override
        public void close() throws IOException {
		}

        @Override
        public void flush() throws IOException {
		}

        @Override
        public void write(char[] buffer, int offset, int length) throws IOException {
		}

        @Override
        public void write(char[] cbuf) throws IOException {
		}

        @Override
        public void write(int c) throws IOException {
		}

        @Override
        public void write(String str, int off, int len) throws IOException {
		}

        @Override
        public void write(String str) throws IOException {
		}
    }

    /** Escape xml text */
    public static String escapeXml(final String input) {
		return null;
	}

    /** Return a Writer that writes escaped XML text to target
     */
    public static @Nonnull Writer getXmlEscapingWriter(@Nonnull Writer target) {
		return null;
	}
}
