/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.sling.scripting.jsp.taglib;

import javax.servlet.Servlet;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.TagSupport;

import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.SyntheticResource;
import org.apache.sling.api.scripting.SlingBindings;
import org.apache.sling.api.scripting.SlingScriptHelper;
import org.apache.sling.api.servlets.ServletResolver;
import org.apache.sling.scripting.jsp.util.JspSlingHttpServletResponseWrapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * The <code>EvalTagHandler</code> implements the
 * <code>&lt;sling:eval&gt;</code> custom tag.
 */
public class EvalTagHandler extends TagSupport {

    private static final long serialVersionUID = 7070941156517599283L;

    /** default log */
    private static final Logger log = LoggerFactory.getLogger(EvalTagHandler.class);

    /** resource argument */
    private Resource resource;

    /** script argument */
    private String script;

    /** resource type argument */
    private String resourceType;

    /** ignore resource type hierarchy */
    private boolean ignoreResourceTypeHierarchy = false;

    /** flush argument */
    private boolean flush = false;


    /**
     * Called after the body has been processed.
     *
     * @return whether additional evaluations of the body are desired
     */
    public int doEndTag() throws JspException {
		return 0;
	}

    /**
     * @see javax.servlet.jsp.tagext.TagSupport#setPageContext(javax.servlet.jsp.PageContext)
     */
    public void setPageContext(final PageContext pageContext) {
	}

    public void setFlush(boolean flush) {
	}

    public void setResource(final Resource rsrc) {
	}

    public void setScript(final String script) {
	}

    public void setResourceType(final String rsrcType) {
	}

    public void setIgnoreResourceTypeHierarchy(final boolean flag) {
	}
}
